
#define IM_NONE     0
#define IM_DRAG     1
#define IM_SELECT   2
#define IM_FSEL     3
#define IM_PICKSP   4
#define IM_PICKEP   5
#define IM_PICKWP   6
#define IM_GETPT    7

#define DM_DOLLY    1
#define DM_VROTATE  2
#define DM_VTURN    3
#define DM_VWALK    4
#define DM_ZOOM     5
#define DM_PAN      6
#define DM_VAUTO    7

#define VM_SHADED     1
#define VM_TEXTURED   4
#define VM_ANTIALIAS  8
#define VM_CHANGED   64
#define VM_REBUILD  128

extern float   VMinZ,VMaxZ;  // z-extents of the world in view-space

class ViewPort
{
  private:
    int     Xcenter;    // center of view plane X
    int     Ycenter;    // center of view plane Y
  public:
    View    V;          // View
    ushort  Width;      // Width  of Viewing-Window in pixels
    ushort  Height;     // Height of Viewing-Window in pixels
    float   Scale;      // window-proportional-scaling factor
    ViewPort(){}
    ViewPort(ushort width, ushort height, float a){
      redim(width, height);
      V.SetViewAngle(a);
      V.Zoom=1.0f;
    }
    void redim(ushort width, ushort height) {
      Width =width;  Xcenter = Width >>1;
      Height=height; Ycenter = Height>>1;
      Scale=((Width<Height)? Width : Height);
    }
    /*vector Proj(vector v) {
      vector s;
      float px = v.x;
      float py = v.y;
      if(V.h>0.0) { px /= v.z*V.h; py /= v.z*V.h; }
      s.x = Xcenter + (V.PanX+px)*V.Zoom*Scale;
      s.y = Ycenter - (V.PanY+py)*V.Zoom*Scale;
      s.z = (v.z-VMinZ)/(VMaxZ-VMinZ)*32000.0f;
      return s;
    }*/
    /*vector RPro(float sx, float sy, float sz) {
      vector v;
      v.z = sz/32000.0f*(VMaxZ-VMinZ)+VMinZ;
      v.y = ((Ycenter-sy)/(V.Zoom*Scale)-V.PanY)*(v.z*V.h);
      v.x = ((sx-Xcenter)/(V.Zoom*Scale)-V.PanX)*(v.z*V.h);
      return v;
    }*/
    //vector Pict(vector v) { return Proj(V.Transform(v)); }
};


class CGraphWin : public CWnd
{
  public:  CGraphWin();

  // Attributes
  public:
    ViewPort    GScreen;
    CPalette    m_cPalette;
    CPalette   *m_pOldPalette;
    CRect       m_oldRect;
    float       m_fRadius;
    CClientDC  *m_pDC;
    int         sx,sy,ex,ey;
    int         InputMode, DragMode, DisplayMode;
	vector      VDir,VLc,VTg;
	CBitmap     CBM;
	float       OZf;

  // Operations
  public:
    void           Init();
    void           CreateRGBPalette(void);
    BOOL           bSetupPixelFormat(void);
    unsigned char  ComponentFromIndex(int i, UINT nbits, UINT shift);
    void           MouseButton(CPoint point, int But);
    void           DrawScene(CDC *hdc);

  // Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGraphWin)
	//}}AFX_VIRTUAL

  // Implementation
  public:
    virtual ~CGraphWin();

  // Generated message map functions
  protected:
	//{{AFX_MSG(CGraphWin)
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnPaint();
	afx_msg void OnDestroy();
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

extern CGraphWin GraphWin;
