
#include "stdafx.h"
#include "general.h"
#include "Primitives.h"
#include "VModel.h"
#include "VModelFile.h"
#include "VModelDoc.h"
#include "GraphWin.h"
#include "TextWin.h"

#include "gl\gl.h"
#include "gl\glu.h"

extern Primitive *RootPtr;
extern void CreateGL1(PrimPtr p, int hl);

static int  OldLine,SnapPick;

bool pointcomplete;

vector     SP,pp;
GLdouble   mm[16];
GLdouble   mp[16];
GLint      mv[16];


/*long int CalcDist(int x1, int y1, int x2, int y2, int xs, int ys)
{
  if((xs < min(x1,x2)-PICKDIST-1) || (xs > max(x1,x2)+PICKDIST+1) || (ys < min(y1,y2)-PICKDIST-1) || (ys > max(y1,y2)+PICKDIST+1)) {
    return sqr((long int)(PICKDIST+1))+3;
  } else {
    int xl,yl;
    int dx=x2-x1; int sdx=sqr(dx);
    int dy=y2-y1; int sdy=sqr(dy);
    if(abs(dx)<abs(dy)){
      yl=(dx*dy*(xs-x1)+y1*sdx+ys*sdy)/(sdy+sdx);
      if((yl<min(y1,y2)) || (yl>max(y1,y2))) return min( sqr(xs-x1)+sqr(ys-y1) , sqr(xs-x2)+sqr(ys-y2) );
      xl=x1+((yl-y1)*dx)/dy;
    } else {
      if(dx==0) return sqr(xs-x1)+sqr(ys-y1);
      xl=(dx*dy*(ys-y1)+x1*sdy+xs*sdx)/(sdy+sdx);
      if((xl<min(x1,x2)) || (xl>max(x1,x2))) return min( sqr(xs-x1)+sqr(ys-y1) , sqr(xs-x2)+sqr(ys-y2) );
      yl=y1+((xl-x1)*dy)/dx;
    }
    return sqr(xs-xl)+sqr(ys-yl);
  }
}*/

void DrawERect(CDC *hdc, int x1, int y1, int x2, int y2)
{
  hdc->MoveTo(x1,y1);
  hdc->LineTo(x2,y1);
  hdc->LineTo(x2,y2);
  hdc->LineTo(x1,y2);
  hdc->LineTo(x1,y1);
}

#define SYMSIZE      5

#define SNAP_END     1
#define SNAP_CENTER1 2
#define SNAP_CENTER2 3

void DrawSnapSym(CDC *hdc, int x, int y, int sym)
{
  switch(sym){
    case SNAP_END:
      hdc->MoveTo(x-SYMSIZE,y-SYMSIZE);
      hdc->LineTo(x+SYMSIZE,y-SYMSIZE);
      hdc->LineTo(x+SYMSIZE,y+SYMSIZE);
      hdc->LineTo(x-SYMSIZE,y+SYMSIZE);
      hdc->LineTo(x-SYMSIZE,y-SYMSIZE);
	  break;
	case SNAP_CENTER1:
      hdc->Ellipse(x-SYMSIZE, y-SYMSIZE, x+SYMSIZE, y+SYMSIZE);
	  break;
	case SNAP_CENTER2:
      hdc->Ellipse(x-SYMSIZE-1, y-SYMSIZE-1, x+SYMSIZE+1, y+SYMSIZE+1);
	  break;
  }
}

vector ParsePoint(char *a)
{
  while(*a==' ' || *a=='\t' || *a=='(') a++;
  vector v=vector(0.0f, 0.0f, 0.0f); char *s; char t;
  if(*a){
	s = a; while((*a != ' ') && (*a != ',') && (*a !=')') && (*a !='\0')) a++;
	t = *a; *a='\0'; v.x = (float)atof(s); *a=t;
    while(*a==' ' || *a=='\t' || *a==',') a++;
    if(*a){
	  s = a; while((*a != ' ') && (*a != ',') && (*a !=')') && (*a !='\0')) a++;
	  t = *a; *a='\0'; v.y = (float)atof(s); *a=t; pointcomplete=true;
      while(*a==' ' || *a=='\t' || *a==',') a++;
      if(*a){
	    s = a; while((*a != ' ') && (*a != ',') && (*a !=')') && (*a !='\0')) a++;
	    t = *a; *a='\0'; v.z = (float)atof(s); *a=t;
	  }
	}
  }
  return v;
}

vector GetPoint(char *Prompt, PrimPtr Selection)
{
  pointcomplete=false;
  GraphWin.InputMode = IM_GETPT; SnapPick=0; RootPtr=Selection;
  TextWin.Input(Prompt);
  GraphWin.InputMode = IM_NONE;
  if(SnapPick) { pointcomplete=true; return pp; }
  return ParsePoint(TextWin.inputstring);
}

extern byte       *BMPbitsB;
extern BITMAPINFO  BMPinfoB;

vector GetWPt(char *Prompt)
{
  GraphWin.InputMode = IM_PICKWP;
  TextWin.Input(Prompt); SP.z=0.0f;
  return SP;
}

PrimPtr SelectObjects(char *Prompt)
{
  GraphWin.InputMode = IM_SELECT; TextWin.Output(1,Prompt);
  RootPtr=NULL;
  do {
    TextWin.Input("- select: ");
  } while(TextWin.inputstring[0] != 0);
  GraphWin.InputMode = IM_NONE;
  return RootPtr;
}

int MarkWindow(PolyMesh *t, BOOL ClrSel)
{
  GLdouble  x0,y0,z0;
  int       ne,ii,i,j,k;
  int       da,fc=0;

  glGetDoublev(GL_MODELVIEW_MATRIX,mm);
  glGetDoublev(GL_PROJECTION_MATRIX,mp);
  glGetIntegerv(GL_VIEWPORT,mv);
  gluUnProject(SPx,SPy,1.0, mm, mp, mv, &x0, &y0, &z0); vector TL=vector((float)x0, (float)y0, (float)z0);
  gluUnProject(EPx,SPy,1.0, mm, mp, mv, &x0, &y0, &z0); vector TR=vector((float)x0, (float)y0, (float)z0);
  gluUnProject(SPx,EPy,1.0, mm, mp, mv, &x0, &y0, &z0); vector BL=vector((float)x0, (float)y0, (float)z0);
  gluUnProject(EPx,EPy,1.0, mm, mp, mv, &x0, &y0, &z0); vector BR=vector((float)x0, (float)y0, (float)z0);
  vector CL=(BL-GraphWin.GScreen.V.Location) * (TL-GraphWin.GScreen.V.Location);
  vector CR=(TR-GraphWin.GScreen.V.Location) * (BR-GraphWin.GScreen.V.Location);
  vector CT=(TL-GraphWin.GScreen.V.Location) * (TR-GraphWin.GScreen.V.Location);
  vector CB=(BR-GraphWin.GScreen.V.Location) * (BL-GraphWin.GScreen.V.Location);
  for(ii=0,i=0; i<(t->nf); i++) {
    if(ClrSel && t->flg) t->flg[i] &= ~SELECTED;
    ne = t->pnv? t->pnv[i] : 3; da=1;
    for(j=0; j<ne; j++){
      if(CL%(t->pts[t->pfv[ii+j]]*t->TM - TL) > 0.0f) da=0;
      if(CR%(t->pts[t->pfv[ii+j]]*t->TM - BR) > 0.0f) da=0;
      if(CT%(t->pts[t->pfv[ii+j]]*t->TM - TL) > 0.0f) da=0;
      if(CB%(t->pts[t->pfv[ii+j]]*t->TM - BR) > 0.0f) da=0;
    }
    if(da){
      //if(SelAdd){
        if(!(t->flg)){ t->flg = new(byte[t->nf]); for(k=0; k<t->nf; k++) t->flg[k] = 0; }
        t->flg[i] |= SELECTED; fc++;
      //} else {
      //  DrawTri(hdc, s1, s2, s3, D_GREY);
      //  if(t->trv[i].flags &   SELECTED) fc++;
      //  t->trv[i].flags &= ~SELECTED;
      //}
    }
    ii += ne;
  }
  if(fc) { glDrawBuffer(GL_FRONT); glDepthFunc(GL_LEQUAL); CreateGL1(t, 2); glCallList(t->OGLL); glFinish(); }
  return fc;
}

PrimPtr SelectFaces(char *Prompt)
{
  TextWin.Output(1,Prompt);
  RootPtr=NULL;
  do {
    GraphWin.InputMode = IM_FSEL; TextWin.Input("- select faces: ");
    //if(!NoInput){
      if(!strnicmp(TextWin.inputstring,"W",1)){
		int      f,sv=0, fc=0;
        SurfPtr  p,s=NULL;
        TextWin.Output(0,  "- select window: first corner: ");
        GraphWin.InputMode=IM_PICKSP; do{ WaitTask(NULL); }while(GraphWin.InputMode==IM_PICKSP);
        TextWin.Output(0,"\n- select window: other corner: ");
        GraphWin.InputMode=IM_PICKEP; do{ WaitTask(NULL); }while(GraphWin.InputMode==IM_PICKEP);
        GraphWin.GetClientRect(&(GraphWin.m_oldRect));
        SPy=GraphWin.m_oldRect.bottom-1-SPy; EPy=GraphWin.m_oldRect.bottom-1-EPy;
        if(EPx < SPx) swap(EPx,SPx); if(EPy < SPy) swap(EPy,SPy);
        p=(SurfPtr)RootPtr;
        while(p){
          if(p->idnt==POLYMESH){ f=MarkWindow((PolyMesh *)p,FALSE); fc+=f; }
          p=(SurfPtr)(p->succ);
        }
        p=(SurfPtr)(VMDoc->VMF.Base);
        while(p){
          if(p->idnt==POLYMESH){
            f=MarkWindow((PolyMesh *)p,TRUE);
            if(f>0){
              s=(SurfPtr)(p->succ); sv=1;
              if(p->succ) p->succ->pred = p->pred;
              if(p->pred) p->pred->succ = p->succ; else VMDoc->VMF.Base = s;
			  p->succ=RootPtr; p->pred=NULL; RootPtr=p; if(p->succ) p->succ->pred=p;
              fc+=f;
            }
          }
          p = sv? s : (SurfPtr)(p->succ); s=NULL; sv=0;
        }
        TextWin.Output(0,"%d faces found.\n",fc);
	  }
	//}
  } while(TextWin.inputstring[0] != 0);
  GraphWin.InputMode = IM_NONE;
  return RootPtr;
}


float CalcLDist(float scl, vector Pr, vector Dr, float n1, vector P1, vector P2)
{
  vector D1 = P2 - P1;
  float  da,tr,t1,t2;
  float  zn = Dr.x * D1.x + Dr.y * D1.y + Dr.z * D1.z; float a = zn/n1;
  float  n2 = D1.x * D1.x + D1.y * D1.y + D1.z * D1.z; float c = zn/n2;
  float  b  = (Dr.x*(P1.x-Pr.x) + Dr.y*(P1.y-Pr.y) + Dr.z*(P1.z-Pr.z)) / n1;
  float  d  = (D1.x*(P1.x-Pr.x) + D1.y*(P1.y-Pr.y) + D1.z*(P1.z-Pr.z)) / n2;
  if(fabs(1.0f-c*a) < 1e-9f) t1=0.0f; else t1= (c*b-d)/(1.0f-c*a);
  if((t1>=0.0f) && (t1<=1.0f)){
    tr = a*t1+b;
    da=Betrag((P1+t1*D1)-(Pr+tr*Dr));
    if(scl) da /= Betrag(Pr-0.5f*((P1+t1*D1)+(Pr+tr*Dr)));
  } else {
    t1=(P1.x*Dr.x-Pr.x*Dr.x + P1.y*Dr.y-Pr.y*Dr.y + P1.z*Dr.z-Pr.z*Dr.z)/n1;
    t2=(P2.x*Dr.x-Pr.x*Dr.x + P2.y*Dr.y-Pr.y*Dr.y + P2.z*Dr.z-Pr.z*Dr.z)/n1;
    if(scl)
	  da=min(Betrag((Pr+t1*Dr)-P1)/Betrag(Pr-P1), Betrag((Pr+t2*Dr)-P2)/Betrag(Pr-P2));
	else
      da=min(Betrag((Pr+t1*Dr)-P1)              , Betrag((Pr+t2*Dr)-P2)              );
  }
  return da;
}

void GetModMat(matrix *M, GLdouble *mc)
{
  GLdouble mm[16]; glGetDoublev(GL_MODELVIEW_MATRIX, mm);
  mc[ 0] = M->M11*mm[ 0] + M->M12*mm[ 4] + M->M13*mm[ 8];
  mc[ 1] = M->M11*mm[ 1] + M->M12*mm[ 5] + M->M13*mm[ 9];
  mc[ 2] = M->M11*mm[ 2] + M->M12*mm[ 6] + M->M13*mm[10];
  mc[ 3] = M->M11*mm[ 3] + M->M12*mm[ 7] + M->M13*mm[11];
	
  mc[ 4] = M->M21*mm[ 0] + M->M22*mm[ 4] + M->M23*mm[ 8];
  mc[ 5] = M->M21*mm[ 1] + M->M22*mm[ 5] + M->M23*mm[ 9];
  mc[ 6] = M->M21*mm[ 2] + M->M22*mm[ 6] + M->M23*mm[10];
  mc[ 7] = M->M21*mm[ 3] + M->M22*mm[ 7] + M->M23*mm[11];
	
  mc[ 8] = M->M31*mm[ 0] + M->M32*mm[ 4] + M->M33*mm[ 8];
  mc[ 9] = M->M31*mm[ 1] + M->M32*mm[ 5] + M->M33*mm[ 9];
  mc[10] = M->M31*mm[ 2] + M->M32*mm[ 6] + M->M33*mm[10];
  mc[11] = M->M31*mm[ 3] + M->M32*mm[ 7] + M->M33*mm[11];
	
  mc[12] = M->M41*mm[ 0] + M->M42*mm[ 4] + M->M43*mm[ 8] + mm[12];
  mc[13] = M->M41*mm[ 1] + M->M42*mm[ 5] + M->M43*mm[ 9] + mm[13];
  mc[14] = M->M41*mm[ 2] + M->M42*mm[ 6] + M->M43*mm[10] + mm[14];
  mc[15] = M->M41*mm[ 3] + M->M42*mm[ 7] + M->M43*mm[11] + mm[15];
}

void GetSnap(int sx, int sy, PrimPtr p, float & dmin, PrimPtr & pmin, int & snp)
{
  GLdouble  x0,y0,z0,mm[16];
  float     da;

  while(p){
    Surface  *s = (PolyMesh *)p; GetModMat(&(s->TM),mm);
    switch(p->idnt){
      case POLYMESH: {
	    PolyMesh *t = (PolyMesh *)p;
        for(int i=0; i<(t->nv); i++){
	      gluProject(t->pts[i].x, t->pts[i].y, t->pts[i].z, mm, mp, mv, &x0, &y0, &z0);
          da=(float)sqrt(sqr(x0-sx)+sqr(y0-sy));
		  if(da<dmin){ dmin=da; pmin=p; pp=t->pts[i]*t->TM; snp=SNAP_END; }
        }
		break; }
      case CUBE: {
	    gluProject(-0.5, -0.5, -0.5, mm, mp, mv, &x0, &y0, &z0); da=(float)sqrt(sqr(x0-sx)+sqr(y0-sy)); if(da<dmin){ dmin=da; pmin=p; pp=vector(-0.5f, -0.5f, -0.5f)*s->TM; snp=SNAP_END; }
	    gluProject(-0.5,  0.5, -0.5, mm, mp, mv, &x0, &y0, &z0); da=(float)sqrt(sqr(x0-sx)+sqr(y0-sy)); if(da<dmin){ dmin=da; pmin=p; pp=vector(-0.5f,  0.5f, -0.5f)*s->TM; snp=SNAP_END; }
	    gluProject(-0.5, -0.5,  0.5, mm, mp, mv, &x0, &y0, &z0); da=(float)sqrt(sqr(x0-sx)+sqr(y0-sy)); if(da<dmin){ dmin=da; pmin=p; pp=vector(-0.5f, -0.5f,  0.5f)*s->TM; snp=SNAP_END; }
	    gluProject(-0.5,  0.5,  0.5, mm, mp, mv, &x0, &y0, &z0); da=(float)sqrt(sqr(x0-sx)+sqr(y0-sy)); if(da<dmin){ dmin=da; pmin=p; pp=vector(-0.5f,  0.5f,  0.5f)*s->TM; snp=SNAP_END; }
	    gluProject( 0.5, -0.5, -0.5, mm, mp, mv, &x0, &y0, &z0); da=(float)sqrt(sqr(x0-sx)+sqr(y0-sy)); if(da<dmin){ dmin=da; pmin=p; pp=vector( 0.5f, -0.5f, -0.5f)*s->TM; snp=SNAP_END; }
	    gluProject( 0.5,  0.5, -0.5, mm, mp, mv, &x0, &y0, &z0); da=(float)sqrt(sqr(x0-sx)+sqr(y0-sy)); if(da<dmin){ dmin=da; pmin=p; pp=vector( 0.5f,  0.5f, -0.5f)*s->TM; snp=SNAP_END; }
	    gluProject( 0.5, -0.5,  0.5, mm, mp, mv, &x0, &y0, &z0); da=(float)sqrt(sqr(x0-sx)+sqr(y0-sy)); if(da<dmin){ dmin=da; pmin=p; pp=vector( 0.5f, -0.5f,  0.5f)*s->TM; snp=SNAP_END; }
	    gluProject( 0.5,  0.5,  0.5, mm, mp, mv, &x0, &y0, &z0); da=(float)sqrt(sqr(x0-sx)+sqr(y0-sy)); if(da<dmin){ dmin=da; pmin=p; pp=vector( 0.5f,  0.5f,  0.5f)*s->TM; snp=SNAP_END; }
		break; }
      case CYLINDER: {
		Cylinder *t = (Cylinder *)p;
		if(t->angle){
	      gluProject(     1.0              ,      0.0              , 0.0, mm, mp, mv, &x0, &y0, &z0); da=(float)sqrt(sqr(x0-sx)+sqr(y0-sy)); if(da<dmin){ dmin=da; pmin=p; pp=vector(   1.0f                      ,    0.0f                      , 0.0f)*t->TM; snp=SNAP_END; }
	      gluProject(t->r_top              ,      0.0              , 1.0, mm, mp, mv, &x0, &y0, &z0); da=(float)sqrt(sqr(x0-sx)+sqr(y0-sy)); if(da<dmin){ dmin=da; pmin=p; pp=vector(t->r_top                     ,    0.0f                      , 1.0f)*t->TM; snp=SNAP_END; }
	      gluProject(t->r_top*cos(t->angle), t->r_top*sin(t->angle), 1.0, mm, mp, mv, &x0, &y0, &z0); da=(float)sqrt(sqr(x0-sx)+sqr(y0-sy)); if(da<dmin){ dmin=da; pmin=p; pp=vector(t->r_top*(float)cos(t->angle), t->r_top*(float)sin(t->angle), 1.0f)*t->TM; snp=SNAP_END; }
	      gluProject(         cos(t->angle),          sin(t->angle), 0.0, mm, mp, mv, &x0, &y0, &z0); da=(float)sqrt(sqr(x0-sx)+sqr(y0-sy)); if(da<dmin){ dmin=da; pmin=p; pp=vector(         (float)cos(t->angle),          (float)sin(t->angle), 0.0f)*t->TM; snp=SNAP_END; }
		}
	    gluProject(0.0, 0.0, 0.0, mm, mp, mv, &x0, &y0, &z0); da=(float)sqrt(sqr(x0-sx)+sqr(y0-sy)); if(da<dmin){ dmin=da; pmin=p; pp=vector(0.0f, 0.0f, 0.0f)*t->TM; snp=SNAP_CENTER1; }
	    gluProject(0.0, 0.0, 1.0, mm, mp, mv, &x0, &y0, &z0); da=(float)sqrt(sqr(x0-sx)+sqr(y0-sy)); if(da<dmin){ dmin=da; pmin=p; pp=vector(0.0f, 0.0f, 1.0f)*t->TM; snp=SNAP_CENTER1; }
		break; }
      case RING: {
		Ring *t = (Ring *)p;
		if(t->angle){
	      gluProject(   1.0              ,    0.0              , 0.0, mm, mp, mv, &x0, &y0, &z0); da=(float)sqrt(sqr(x0-sx)+sqr(y0-sy)); if(da<dmin){ dmin=da; pmin=p; pp=vector(   1.0f                    ,    0.0f                    , 0.0f)*t->TM; snp=SNAP_END; }
	      gluProject(t->r_i              ,    0.0              , 0.0, mm, mp, mv, &x0, &y0, &z0); da=(float)sqrt(sqr(x0-sx)+sqr(y0-sy)); if(da<dmin){ dmin=da; pmin=p; pp=vector(t->r_i                     ,    0.0f                    , 0.0f)*t->TM; snp=SNAP_END; }
	      gluProject(t->r_i*cos(t->angle), t->r_i*sin(t->angle), 0.0, mm, mp, mv, &x0, &y0, &z0); da=(float)sqrt(sqr(x0-sx)+sqr(y0-sy)); if(da<dmin){ dmin=da; pmin=p; pp=vector(t->r_i*(float)cos(t->angle), t->r_i*(float)sin(t->angle), 0.0f)*t->TM; snp=SNAP_END; }
	      gluProject(       cos(t->angle),        sin(t->angle), 0.0, mm, mp, mv, &x0, &y0, &z0); da=(float)sqrt(sqr(x0-sx)+sqr(y0-sy)); if(da<dmin){ dmin=da; pmin=p; pp=vector(       (float)cos(t->angle),        (float)sin(t->angle), 0.0f)*t->TM; snp=SNAP_END; }
		}
	    gluProject(0.0, 0.0, 0.0, mm, mp, mv, &x0, &y0, &z0); da=(float)sqrt(sqr(x0-sx)+sqr(y0-sy)); if(da<dmin){ dmin=da; pmin=p; pp=vector(0.0f, 0.0f, 0.0f)*t->TM; snp=SNAP_CENTER1; }
		break; }
      case SPHERE: {
		Sphere *t = (Sphere *)p;
		if(((t->ustart > -1.5708f) || t->vangle) && ((t->ustart > 0.001f) || (t->ustart < -0.001f))){
	      gluProject(0.0, 0.0, sin(t->ustart), mm, mp, mv, &x0, &y0, &z0); da=(float)sqrt(sqr(x0-sx)+sqr(y0-sy)); if(da<dmin){ dmin=da; pmin=p; pp=vector(0.0f, 0.0f, (float)sin(t->ustart))*t->TM; snp=SNAP_CENTER1; }
		}
		if(((t->ustop < 1.5707f) || t->vangle) && ((t->ustop > 0.001f) || (t->ustop < -0.001f))){
	      gluProject(0.0, 0.0, sin(t->ustop ), mm, mp, mv, &x0, &y0, &z0); da=(float)sqrt(sqr(x0-sx)+sqr(y0-sy)); if(da<dmin){ dmin=da; pmin=p; pp=vector(0.0f, 0.0f, (float)sin(t->ustop ))*t->TM; snp=SNAP_CENTER1; }
		}
		if(t->vangle){
		  if(t->ustart > -1.5708f){
	        gluProject(               cos(t->ustart), 0.0                          , sin(t->ustart), mm, mp, mv, &x0, &y0, &z0); da=(float)sqrt(sqr(x0-sx)+sqr(y0-sy)); if(da<dmin){ dmin=da; pmin=p; pp=vector((float)                cos(t->ustart) ,         0.0f                          , (float)sin(t->ustart))*t->TM; snp=SNAP_END; }
	        gluProject(cos(t->vangle)*cos(t->ustart), sin(t->vangle)*cos(t->ustart), sin(t->ustart), mm, mp, mv, &x0, &y0, &z0); da=(float)sqrt(sqr(x0-sx)+sqr(y0-sy)); if(da<dmin){ dmin=da; pmin=p; pp=vector((float)(cos(t->vangle)*cos(t->ustart)), (float)(sin(t->vangle)*cos(t->ustart)), (float)sin(t->ustart))*t->TM; snp=SNAP_END; }
		  }
		  if(t->ustop  <  1.5707f){
	        gluProject(               cos(t->ustop ), 0.0                          , sin(t->ustop ), mm, mp, mv, &x0, &y0, &z0); da=(float)sqrt(sqr(x0-sx)+sqr(y0-sy)); if(da<dmin){ dmin=da; pmin=p; pp=vector((float)                cos(t->ustop ) ,         0.0f                          , (float)sin(t->ustop ))*t->TM; snp=SNAP_END; }
	        gluProject(cos(t->vangle)*cos(t->ustop ), sin(t->vangle)*cos(t->ustop ), sin(t->ustop ), mm, mp, mv, &x0, &y0, &z0); da=(float)sqrt(sqr(x0-sx)+sqr(y0-sy)); if(da<dmin){ dmin=da; pmin=p; pp=vector((float)(cos(t->vangle)*cos(t->ustop )), (float)(sin(t->vangle)*cos(t->ustop )), (float)sin(t->ustop ))*t->TM; snp=SNAP_END; }
		  }
		}
		gluProject(0.0, 0.0, 0.0, mm, mp, mv, &x0, &y0, &z0); da=(float)sqrt(sqr(x0-sx)+sqr(y0-sy)); if(da<dmin){ dmin=da; pmin=p; pp=vector(0.0f, 0.0f, 0.0f)*t->TM; snp=SNAP_CENTER2; }
		break; }
      case TORUS: {
		Torus *t = (Torus *)p;
		if(t->vangle){
		  if(t->ustart || (t->ustop  <  6.2831f)){
	        gluProject((t->R1 + t->R2 * cos(t->ustart))                 ,                  0.0                             , t->R2 * sin(t->ustart), mm, mp, mv, &x0, &y0, &z0); da=(float)sqrt(sqr(x0-sx)+sqr(y0-sy)); if(da<dmin){ dmin=da; pmin=p; pp=vector((t->R1 + t->R2 * cosf(t->ustart))                  ,                  0.0f                              , t->R2 * sinf(t->ustart))*t->TM; snp=SNAP_END; }
	        gluProject((t->R1 + t->R2 * cos(t->ustart)) * cos(t->vangle), (t->R1 + t->R2 * cos(t->ustart)) * sin(t->vangle), t->R2 * sin(t->ustart), mm, mp, mv, &x0, &y0, &z0); da=(float)sqrt(sqr(x0-sx)+sqr(y0-sy)); if(da<dmin){ dmin=da; pmin=p; pp=vector((t->R1 + t->R2 * cosf(t->ustart)) * cosf(t->vangle), (t->R1 + t->R2 * cosf(t->ustart)) * sinf(t->vangle), t->R2 * sinf(t->ustart))*t->TM; snp=SNAP_END; }
	        gluProject((t->R1 + t->R2 * cos(t->ustop ))                 ,                  0.0                             , t->R2 * sin(t->ustop ), mm, mp, mv, &x0, &y0, &z0); da=(float)sqrt(sqr(x0-sx)+sqr(y0-sy)); if(da<dmin){ dmin=da; pmin=p; pp=vector((t->R1 + t->R2 * cosf(t->ustop ))                  ,                  0.0f                              , t->R2 * sinf(t->ustop ))*t->TM; snp=SNAP_END; }
	        gluProject((t->R1 + t->R2 * cos(t->ustop )) * cos(t->vangle), (t->R1 + t->R2 * cos(t->ustop )) * sin(t->vangle), t->R2 * sin(t->ustop ), mm, mp, mv, &x0, &y0, &z0); da=(float)sqrt(sqr(x0-sx)+sqr(y0-sy)); if(da<dmin){ dmin=da; pmin=p; pp=vector((t->R1 + t->R2 * cosf(t->ustop )) * cosf(t->vangle), (t->R1 + t->R2 * cosf(t->ustop )) * sinf(t->vangle), t->R2 * sinf(t->ustop ))*t->TM; snp=SNAP_END; }
		  }
		}
		gluProject(0.0, 0.0, 0.0, mm, mp, mv, &x0, &y0, &z0); da=(float)sqrt(sqr(x0-sx)+sqr(y0-sy)); if(da<dmin){ dmin=da; pmin=p; pp=vector(0.0f, 0.0f, 0.0f)*t->TM; snp=SNAP_CENTER2; }
		break; }
    }
    p=p->succ;
  }
}

void CGraphWin::MouseButton(CPoint point, int But) 
{
  GLdouble  x0,y0,z0;
  float     PA,da,dmin;
  int       ne,ii,i,j,k;
  int       f,fc;
  SurfPtr   s,p,pmin;
  PrimPtr   pm;
  int       sm,Hit,OldROP;
  CDC      *hdc;
  vector    P1,D1;
  float     n1;

  switch(InputMode){
    case IM_DRAG:
	  SetCapture();
      sx=point.x; sy=point.y;
	  switch(DragMode){
	    case DM_DOLLY: VDir = GScreen.V.Target - GScreen.V.Location; break;
		case DM_ZOOM: OZf = (GScreen.V.h)? 2.0f*(float)atan(GScreen.V.h/2.0f) : GScreen.V.Zoom; break;
	    case DM_PAN: VLc = GScreen.V.Location; VTg = GScreen.V.Target; break;
	  }
	  break;
    case IM_PICKWP:
      SPx=point.x; SPy=point.y;
      GetClientRect(&m_oldRect);
      if(BMPbitsB){
	    float fx=(float)m_oldRect.right /(float)BMPinfoB.bmiHeader.biWidth;
	    float fy=(float)m_oldRect.bottom/(float)BMPinfoB.bmiHeader.biHeight;
	    if(fy>fx){
	      SP.x = (float)SPx/fx; SP.y = ((float)SPy - (m_oldRect.bottom - fx*BMPinfoB.bmiHeader.biHeight)*0.5f)/fx;
	    } else {
	      SP.x = ((float)SPx - (m_oldRect.right - fy*BMPinfoB.bmiHeader.biWidth)*0.5f)/fy; SP.y = (float)SPy/fy;
	    }
      }
      InputMode=IM_NONE; TextWin.KeyIn("(%3.1f, %3.1f)\n",SP.x,SP.y);
      break;
    case IM_PICKSP:
      SPx=point.x; SPy=point.y;
      InputMode=IM_NONE;
      break;
    case IM_PICKEP:
      if(OldLine){
        hdc = GetDC(); OldROP=hdc->SetROP2(R2_NOT);
        DrawERect(hdc,SPx,SPy,EPx,EPy); OldLine=0;
        hdc->SetROP2(OldROP); ReleaseDC(hdc);
      }
      EPx=point.x; EPy=point.y;
      InputMode=IM_NONE;
      break;
    case IM_GETPT:
	  GetClientRect(&m_oldRect);
	  glGetDoublev(GL_PROJECTION_MATRIX,mp); glGetIntegerv(GL_VIEWPORT,mv);
      dmin = PICKDIST+1.0f; pm=NULL; sm=0;
      GetSnap(point.x, m_oldRect.bottom-point.y-1, VMDoc->VMF.Base, dmin, pm, sm);
      GetSnap(point.x, m_oldRect.bottom-point.y-1, RootPtr,         dmin, pm, sm);
	  if(OldLine){
        hdc = GetDC(); CDC mem;
		mem.CreateCompatibleDC(hdc);
        mem.SelectObject(CBM);
        hdc->BitBlt(EPx-7,EPy-7,16,16,&mem,0,0,SRCCOPY);
		OldLine=0;
        ReleaseDC(hdc);
	  }
	  if(!sm){
	    GetClientRect(&m_oldRect);
        sx=point.x; sy=m_oldRect.bottom-point.y-1;
        glGetDoublev(GL_MODELVIEW_MATRIX,mm);
        glGetDoublev(GL_PROJECTION_MATRIX,mp);
        glGetIntegerv(GL_VIEWPORT,mv);
	    gluUnProject(sx,sy,1.0, mm, mp, mv, &x0, &y0, &z0);
        if(GScreen.V.h){
	      P1 = GScreen.V.Location;
	      D1 = vector((float)x0, (float)y0, (float)z0)-P1;
		} else {
	      P1 = vector((float)x0, (float)y0, (float)z0);
	      D1 = GScreen.V.Target-GScreen.V.Location;
		}
        vector N=vector(0.0f, 0.0f, 1.0f);
        float t = ((-P1)%N)/(D1%N);
        pp = P1+t*D1;
	  }
      TextWin.KeyIn("(%f, %f, %f)\n",pp.x, pp.y, pp.z); SnapPick=1;
      break;
	case IM_SELECT:
	  GetClientRect(&m_oldRect);
      sx=point.x; sy=m_oldRect.bottom-point.y-1;
      glGetDoublev(GL_MODELVIEW_MATRIX,mm);
      glGetDoublev(GL_PROJECTION_MATRIX,mp);
      glGetIntegerv(GL_VIEWPORT,mv);
	  gluUnProject(sx,sy,1.0, mm, mp, mv, &x0, &y0, &z0);
      if(GScreen.V.h){
	    P1 = GScreen.V.Location;
	    D1 = vector((float)x0, (float)y0, (float)z0)-P1;
        PA = (PICKDIST+1)*GScreen.V.h/m_oldRect.right;
      } else {
	    P1 = vector((float)x0, (float)y0, (float)z0);
	    D1 = GScreen.V.Target-GScreen.V.Location;
        PA = (PICKDIST+1)*GScreen.V.Zoom/m_oldRect.right;
      }
      n1   = D1.x * D1.x + D1.y * D1.y + D1.z * D1.z;
	  p    = (Surface *)(But==1? VMDoc->VMF.Base : RootPtr);
      dmin = PA+1.0f;
      while(p){
        if((p->idnt==POLYMESH)){
		  PolyMesh *t = (PolyMesh *)p;
          for(ii=0,i=0; i<(t->nf); i++) {
            ne = t->pnv? t->pnv[i] : 3;
            for(j=0; j<(ne-1); j++){
	          da=CalcLDist(GScreen.V.h, P1, D1, n1, t->pts[t->pfv[ii+j]]*t->TM, t->pts[t->pfv[ii+j+1]]*t->TM);
			  if(da<dmin){ dmin=da; pmin=p; }
            }
	        da=CalcLDist(GScreen.V.h, P1, D1, n1, t->pts[t->pfv[ii+ne-1]]*t->TM, t->pts[t->pfv[ii]]*t->TM);
			if(da<dmin){ dmin=da; pmin=p; }
            ii += ne;
          }
        }
        if((p->idnt==CUBE) || (p->idnt==SPHERE) || (p->idnt==CYLINDER) || (p->idnt==RING) || (p->idnt==PARABOLOID) || (p->idnt==TORUS) || (p->idnt==FUNCTION)){
          for(i=0; i<(p->mesh.nl); i++) {
	        da=CalcLDist(GScreen.V.h, P1, D1, n1, p->mesh.pts[p->mesh.lin[i].v1]*p->TM, p->mesh.pts[p->mesh.lin[i].v2]*p->TM);
			if(da<dmin){
			  if((p->mesh.lin[i].flags & 64) || (p->mesh.lin[i].n2 == NO_NORMAL)){
			    dmin=da; pmin=p;
			  } else {
                vector pm = unit(((GraphWin.GScreen.V.h)? ((p->mesh.pts[p->mesh.lin[i].v1] + p->mesh.pts[p->mesh.lin[i].v2])/2.0f)*p->TM : GraphWin.GScreen.V.Target) - GraphWin.GScreen.V.Location);
                float w1 = pm % unit(p->mesh.snm[p->mesh.lin[i].n1]);
                float w2 = pm % unit(p->mesh.snm[p->mesh.lin[i].n2]);
                if( ((w1<0.0f) && (w2>0.0f)) || ((w1>0.0f) && (w2<0.0f)) ){
			      dmin=da; pmin=p;
				}
			  }
			}
          }
        }
        p=(Surface *)(p->succ);
      }
	  if(dmin<=PA){
        if(pmin->name){ /*NoInput=TRUE;*/ TextWin.KeyIn("%s\n",pmin->name); }
        glDrawBuffer(GL_FRONT); glDepthFunc(GL_LEQUAL);
		CreateGL1(pmin, But==1? 1 : 0); glCallList(pmin->OGLL); glFinish();
        if(pmin->succ) pmin->succ->pred = pmin->pred;
        if(pmin->pred){
		  pmin->pred->succ = pmin->succ;
		} else {
          if(But==1) VMDoc->VMF.Base = pmin->succ; else RootPtr = pmin->succ;
		}
        if(But==1){
          pmin->succ = RootPtr; if(RootPtr) RootPtr->pred = pmin; RootPtr=pmin;
        } else {
          pmin->succ = VMDoc->VMF.Base; if(VMDoc->VMF.Base) VMDoc->VMF.Base->pred = pmin; VMDoc->VMF.Base=pmin;
        }
        pmin->pred = NULL;
      }
	  break;
	case IM_FSEL:
	  GetClientRect(&m_oldRect);
      sx=point.x; sy=m_oldRect.bottom-point.y-1;
      glGetDoublev(GL_MODELVIEW_MATRIX,mm);
      glGetDoublev(GL_PROJECTION_MATRIX,mp);
      glGetIntegerv(GL_VIEWPORT,mv);
	  gluUnProject(sx,sy,1.0, mm, mp, mv, &x0, &y0, &z0);
      if(GScreen.V.h){
	    P1 = GScreen.V.Location;
	    D1 = vector((float)x0, (float)y0, (float)z0)-P1;
        PA = (PICKDIST+1)*GScreen.V.h/m_oldRect.right;
      } else {
	    P1 = vector((float)x0, (float)y0, (float)z0);
	    D1 = GScreen.V.Target-GScreen.V.Location;
        PA = (PICKDIST+1)*GScreen.V.Zoom/m_oldRect.right;
      }
      n1 = D1.x * D1.x + D1.y * D1.y + D1.z * D1.z; dmin=PA+1.0f; fc=0;
      dmin=PA+1.0f; fc=0; p = (Surface *)RootPtr;
      while(p){
        if(p->idnt==POLYMESH){
		  PolyMesh *t = (PolyMesh *)p;
          for(ii=0,i=0,f=0; i<(t->nf); i++) {
            ne = t->pnv? t->pnv[i] : 3; Hit=0;
            for(j=0; j<(ne-1); j++){
	          if(CalcLDist(GScreen.V.h, P1, D1, n1, t->pts[t->pfv[ii+j]]*t->TM, t->pts[t->pfv[ii+j+1]]*t->TM)<=PA) Hit=1;
			}
	        if(CalcLDist(GScreen.V.h, P1, D1, n1, t->pts[t->pfv[ii+ne-1]]*t->TM, t->pts[t->pfv[ii]]*t->TM)<=PA) Hit=1;
			if(Hit){
              if(But==1){
			    t->flg[i] |=  SELECTED;
			  } else {
			    t->flg[i] &= ~SELECTED;
			  }
              fc++; f++;
			}
            ii += ne;
          }
          if(f) { glDrawBuffer(GL_FRONT); glDepthFunc(GL_LEQUAL); CreateGL1(p, But==1? 2 : 0); glCallList(p->OGLL); glFinish(); }
        }
        p=(Surface *)(p->succ);
      }
      if(But==1){
	    p = (Surface *)(VMDoc->VMF.Base);
        while(p){
          if(p->idnt==POLYMESH){
		    PolyMesh *t = (PolyMesh *)p;
            for(f=0,ii=0,i=0; i<(t->nf); i++) {
              if(t->flg) t->flg[i] &= ~SELECTED; Hit=0;
              ne = t->pnv? t->pnv[i] : 3;
              for(j=0; j<(ne-1); j++){
	            if(CalcLDist(GScreen.V.h, P1, D1, n1, t->pts[t->pfv[ii+j]]*t->TM, t->pts[t->pfv[ii+j+1]]*t->TM)<=PA) Hit=1;
			  }
	          if(CalcLDist(GScreen.V.h, P1, D1, n1, t->pts[t->pfv[ii+ne-1]]*t->TM, t->pts[t->pfv[ii]]*t->TM)<=PA) Hit=1;
			  if(Hit){
                if(!(t->flg)){ t->flg = new(byte[t->nf]); for(k=0; k<t->nf; k++) t->flg[k] = 0; }
                t->flg[i] |= SELECTED; f++;
			  }
              ii += ne;
            }
		    if(f>0){
              glDrawBuffer(GL_FRONT); glDepthFunc(GL_LEQUAL); CreateGL1(p, But==1? 2 : 0); glCallList(p->OGLL); glFinish();
              s=p; p=(Surface *)(p->pred);
              if(s->succ) s->succ->pred = s->pred;
              if(s->pred) s->pred->succ = s->succ; else VMDoc->VMF.Base = s->succ;
              s->succ = RootPtr; s->pred = NULL; if(RootPtr) RootPtr->pred = s; RootPtr = s;
			  fc+=f;
		    }
          }
          if(p && ((p->idnt==CUBE) || (p->idnt==SPHERE) || (p->idnt==CYLINDER) || (p->idnt==RING) || (p->idnt==TORUS))){
            Hit=0;
			for(i=0; i<(p->mesh.nl); i++) {
	          da=CalcLDist(GScreen.V.h, P1, D1, n1, p->mesh.pts[p->mesh.lin[i].v1]*p->TM, p->mesh.pts[p->mesh.lin[i].v2]*p->TM);
			  if(da<=PA){
			    if((p->mesh.lin[i].flags & 64) || (p->mesh.lin[i].n2 == NO_NORMAL)){
			      Hit=1;
				} else {
                  vector pm = unit(((GraphWin.GScreen.V.h)? ((p->mesh.pts[p->mesh.lin[i].v1] + p->mesh.pts[p->mesh.lin[i].v2])/2.0f)*p->TM : GraphWin.GScreen.V.Target) - GraphWin.GScreen.V.Location);
                  float w1 = pm % unit(p->mesh.snm[p->mesh.lin[i].n1]);
                  float w2 = pm % unit(p->mesh.snm[p->mesh.lin[i].n2]);
                  if( ((w1<0.0f) && (w2>0.0f)) || ((w1>0.0f) && (w2<0.0f)) ){
			        Hit=1;
				  }
				}
			  }
			}
		    if(Hit){
              glDrawBuffer(GL_FRONT); glDepthFunc(GL_LEQUAL); CreateGL1(p, But==1? 1 : 0); glCallList(p->OGLL); glFinish();
              s=p; p=(Surface *)(p->pred);
              if(s->succ) s->succ->pred = s->pred;
              if(s->pred) s->pred->succ = s->succ; else VMDoc->VMF.Base = s->succ;
              s->succ = RootPtr; s->pred = NULL; if(RootPtr) RootPtr->pred = s; RootPtr = s;
			  fc+=1;
		    }
		  }
          if(p) p=(Surface *)(p->succ);
		}
      }

	  TextWin.KeyIn("%d %s found.\n",fc,(fc==1? "face" : "faces"));
	  break;
  }
  return;
}


void CGraphWin::OnLButtonDown(UINT nFlags, CPoint point) 
{
  MouseButton(point, 1);
}

void CGraphWin::OnRButtonDown(UINT nFlags, CPoint point) 
{
  MouseButton(point, 2);
}

extern DWORD gs;
int    crs=0;

void CGraphWin::OnMouseMove(UINT nFlags, CPoint point) 
{
  GLdouble  x0,y0,z0;
  PrimPtr   pmin;
  float     dmin;
  int       smin;

  static int  OPx,OPy;
  int         OldROP;
  CDC        *hdc;
  switch(InputMode){
    case IM_PICKEP:
      hdc = GetDC(); OldROP=hdc->SetROP2(R2_NOT);
      OPx=EPx; OPy=EPy; EPx=point.x; EPy=point.y;
      if(OldLine){
        DrawERect(hdc,SPx,SPy,OPx,OPy); OldLine=0;
      }
      DrawERect(hdc,SPx,SPy,EPx,EPy); OldLine=1;
      hdc->SetROP2(OldROP); ReleaseDC(hdc);
      break;
    case IM_GETPT:
	  GetClientRect(&m_oldRect);
	  glGetDoublev(GL_PROJECTION_MATRIX,mp); glGetIntegerv(GL_VIEWPORT,mv);
      dmin = PICKDIST+1.0f;
      GetSnap(point.x, m_oldRect.bottom-point.y-1, VMDoc->VMF.Base, dmin, pmin, smin);
      GetSnap(point.x, m_oldRect.bottom-point.y-1, RootPtr,         dmin, pmin, smin);
      hdc = GetDC();
	  glGetDoublev(GL_MODELVIEW_MATRIX, mm);
	  gluProject(pp.x, pp.y, pp.z, mm, mp, mv, &x0, &y0, &z0);
      OPx=EPx; OPy=EPy; EPx=(int)(x0+0.5); EPy=m_oldRect.bottom-(int)(y0+0.5)-1;
	  if(OldLine){
        CDC        mem;
		mem.CreateCompatibleDC(hdc);
        mem.SelectObject(CBM);
        hdc->BitBlt(OPx-7,OPy-7,16,16,&mem,0,0,SRCCOPY);
		OldLine=0;
	  }
	  if(dmin<=PICKDIST){
        CDC        mem;
		mem.CreateCompatibleDC(hdc);
        mem.SelectObject(CBM);
        mem.BitBlt(0,0,16,16,hdc,EPx-7,EPy-7,SRCCOPY);
        CPen NewPen; CPen *OldPen;
        NewPen.CreatePen(PS_SOLID,1,0x00FF00FF);
        OldPen=hdc->SelectObject(&NewPen);
		DrawSnapSym(hdc,EPx,EPy,smin); OldLine=1;
        hdc->SelectObject(OldPen);
        NewPen.DeleteObject();
	  }
      ReleaseDC(hdc);
      break;
    case IM_DRAG:
	  if(GetCapture() == this){
        ex=point.x; ey=point.y;
		switch(DragMode){
		  case DM_DOLLY:
			GScreen.V.Location = GScreen.V.Target - (float)exp((float)(ey-sy)/100.0f) * VDir;
			break;
		  case DM_ZOOM:
			if(GScreen.V.h){
              GScreen.V.SetViewAngle(lim(0.035f, OZf+(float)(ey-sy)/100.0f, 2.8f));
			} else {
			  GScreen.V.Zoom = OZf * (float)pow(10.0, ((double)(ey-sy))/100.0);
			}
			break;
		  case DM_PAN: {
			vector N  = unit(GScreen.V.Target - GScreen.V.Location);
            vector V  = GScreen.V.Up;
            vector U  = N*V;
            GScreen.V.Target   = VTg + V * ((float)(ey-sy)/100.0f*GScreen.V.Zoom) - U * ((float)(ex-sx)/100.0f*GScreen.V.Zoom);
			GScreen.V.Location = VLc + V * ((float)(ey-sy)/100.0f*GScreen.V.Zoom) - U * ((float)(ex-sx)/100.0f*GScreen.V.Zoom);
		    } break;
		  case DM_VROTATE: {
			float ry = ((float)(ex-sx))*(Pi/180.0f); sx=ex;
			float rx = ((float)(ey-sy))*(Pi/180.0f); sy=ey;
			vector N  = unit(GScreen.V.Target - GScreen.V.Location);
            vector V  = GScreen.V.Up;
            vector U  = N*V;
			matrix Rx = InitAxisRot(GScreen.V.Target.x, GScreen.V.Target.y, GScreen.V.Target.z, U.x, U.y, U.z, rx);
			matrix Ry = InitAxisRot(GScreen.V.Target.x, GScreen.V.Target.y, GScreen.V.Target.z, V.x, V.y, V.z, ry);
            GScreen.V.Location = GScreen.V.Location * Rx * Ry;
			// calculate new orthogonal up-vector
			glMatrixMode(GL_PROJECTION); glPushMatrix(); glLoadIdentity();
            gluLookAt(GScreen.V.Location.x, GScreen.V.Location.y, GScreen.V.Location.z,
                      GScreen.V.Target.x,   GScreen.V.Target.y,   GScreen.V.Target.z,
  	    	          GScreen.V.Up.x,       GScreen.V.Up.y,       GScreen.V.Up.z);
            float pm[16]; glGetFloatv(GL_PROJECTION_MATRIX, pm);
            GScreen.V.Up.x = pm[1]; GScreen.V.Up.y = pm[5]; GScreen.V.Up.z = pm[9];
            glPopMatrix(); glMatrixMode(GL_MODELVIEW); } break;
		  case DM_VTURN: {
			float ry = ((float)(ex-sx))*(Pi/360.0f); sx=ex;
			float rx = ((float)(ey-sy))*(Pi/360.0f); sy=ey;
			vector N  = unit(GScreen.V.Target - GScreen.V.Location);
            vector V  = GScreen.V.Up;
            vector U  = N*V;
			matrix Rx = InitAxisRot(GScreen.V.Location.x, GScreen.V.Location.y, GScreen.V.Location.z, U.x, U.y, U.z, rx);
			matrix Ry = InitAxisRot(GScreen.V.Location.x, GScreen.V.Location.y, GScreen.V.Location.z, V.x, V.y, V.z, ry);
            GScreen.V.Target = GScreen.V.Target * Rx * Ry;
			// calculate new orthogonal up-vector
			glMatrixMode(GL_PROJECTION); glPushMatrix(); glLoadIdentity();
            gluLookAt(GScreen.V.Location.x, GScreen.V.Location.y, GScreen.V.Location.z,
                      GScreen.V.Target.x,   GScreen.V.Target.y,   GScreen.V.Target.z,
  	    	          GScreen.V.Up.x,       GScreen.V.Up.y,       GScreen.V.Up.z);
            float pm[16]; glGetFloatv(GL_PROJECTION_MATRIX, pm);
            GScreen.V.Up.x = pm[1]; GScreen.V.Up.y = pm[5]; GScreen.V.Up.z = pm[9];
            glPopMatrix(); glMatrixMode(GL_MODELVIEW); } break;
		  case DM_VWALK: {
			if(!crs){
			  float ry = ((float)(ex-sx))*(Pi/360.0f);
			  float rx = ((float)(ey-sy))*(Pi/360.0f);
			  vector N  = unit(GScreen.V.Target - GScreen.V.Location);
              vector V  = GScreen.V.Up;
              vector U  = N*V;
			  matrix Rx = InitAxisRot(GScreen.V.Location.x, GScreen.V.Location.y, GScreen.V.Location.z, U.x , U.y , U.z , rx);
			  matrix Ry = InitAxisRot(GScreen.V.Location.x, GScreen.V.Location.y, GScreen.V.Location.z, 0.0f, 0.0f, 1.0f, ry);
              GScreen.V.Target = GScreen.V.Target * Ry * Rx;
			  // calculate new orthogonal up-vector
			  glMatrixMode(GL_PROJECTION); glPushMatrix(); glLoadIdentity();
              gluLookAt(GScreen.V.Location.x, GScreen.V.Location.y, GScreen.V.Location.z,
                        GScreen.V.Target.x,   GScreen.V.Target.y,   GScreen.V.Target.z,
  	    	            0.0f,                 0.0f,                 1.0f                );
              float pm[16]; glGetFloatv(GL_PROJECTION_MATRIX, pm);
              GScreen.V.Up.x = pm[1]; GScreen.V.Up.y = pm[5]; GScreen.V.Up.z = pm[9];
              RECT Win; GetWindowRect(&Win); crs=1; SetCursorPos((Win.left+Win.right)/2, (Win.top+Win.bottom)/2);
			  glPopMatrix(); glMatrixMode(GL_MODELVIEW);
			} else crs=0;
			sx=ex; sy=ey;
		  } break;
		}
		if((DragMode!=DM_VWALK)||(gs<=0)) InvalidateRect(NULL,FALSE);
      }
	  break;
  }
  return;
}


void CGraphWin::OnLButtonUp(UINT nFlags, CPoint point) 
{
  switch(InputMode){
    case IM_DRAG:
	  if(DragMode!=DM_VWALK){
	    if(GetCapture() == this){
          ReleaseCapture(); InputMode = IM_NONE;
        }
	  }
	  break;
  }
  return;
}

