
#include "stdafx.h"

#include "general.h"
#include "Primitives.h"
#include "VModel.h"
#include "TextWin.h"
#include "VModelFile.h"
#include "VModelDoc.h"
#include "GraphWin.h"

#include "gl\glu.h"

extern "C" {
  #include "OpenImage.h"
}

extern char filename[320];

const float OB64 = 1.0f/64.0f;

char phfilename[320] = "";
char txfilename[320] = "";

vector Cm;
vector P1[9],P2[9],S1[9]; 
int eg[9];
//float eg[9];
vector pt[4];

float XRes=480.0f;//768.0f;
float YRes=360.0f;//576.0f;
float fx,fy;

float Vh ,aa ,ea, ua;
float Vh0,ua0;

int   nlv,qcc;

void GetTex2D();


vector bilinear(float x, float y, vector v00, vector v10, vector v01, vector v11)
{
  return blend(y, blend(x, v00, v01), blend(x, v10, v11));
}

float minimize1(float x, float s, float g, float f(float))
{
  float gr=f(x+s);
  float gm=f(x  );
  float gl=f(x-s);

  CDC *hdc;
  hdc = GraphWin.GetDC();
  while(s>g){
    hdc->MoveTo ((int)(200.0f*x),  0);
    hdc->LineTo ((int)(200.0f*x), 30);
    if((gr>=gm) && (gl>=gm)){
	  s*=0.5f;
	  if(s>g){
        gr=f(x+s);
        gl=f(x-s);
	  }
	} else if(gr<gm){
	  x+=s; gl=gm; gm=gr;
      gr=f(x+s);
    } else if(gl<gm){
	  x-=s; gr=gm; gm=gl;
      gl=f(x-s);
	}
  }
  GraphWin.ReleaseDC(hdc);
  return x;
}

float minimize2(float & xo, float & yo, float s, float g, float f(float, float))
{
  float x=xo, y=yo;
  float dx1 = f(x+0.1f*s, y) - f(x-0.1f*s, y);
  float dy1 = f(x, y+0.1f*s) - f(x, y-0.1f*s);
  float dx  = (float)(-dx1/sqrt(dx1*dx1+dy1*dy1));
  float dy  = (float)(-dy1/sqrt(dx1*dx1+dy1*dy1));
  float r,a = ((fabs(dx)>0.001)? float(atan(dy/dx)) : Pi_2) + ((dx<0.0)? Pi : 0.0f); if(a<0.0) a+=TwoPi;
  float g0,gr,gm,gl;
  int   c=0;
  while((s>g) && (c<500)){
    g0=f(x,y); r=0.1f;

    gr=f((float)(x+s*cos(a+r)), float(y+s*sin(a+r)));
    gm=f((float)(x+s*cos(a  )), float(y+s*sin(a  )));
    gl=f(float(x+s*cos(a-r)), float(y+s*sin(a-r)));

    while(r>0.02f){
      if((gr>=gm) && (gl>=gm)){
	    r*=0.5f;
	    if(r>0.02f){
			gr=f((float)(x+s*cos(a+r)), float(y+s*sin(a+r)));
			gl=f(float(x+s*cos(a-r)), float(y+s*sin(a-r)));
	    }
	  } else if(gr<gm){
	    a+=r; gl=gm; gm=gr;
			gr=f((float)(x+s*cos(a+r)), float(y+s*sin(a+r)));
      } else if(gl<gm){
	    a-=r; gr=gm; gm=gl;
   gl=f(float(x+s*cos(a-r)), float(y+s*sin(a-r)));
	  }
    }

	if(f(float(x+s*cos(a)), float(y+s*sin(a)))<g0){
	  x+=float(s*cos(a));
	  y+=float(s*sin(a));
	} else {
	  s *= 0.5f;
	}
	c++;
  }
  xo=x; yo=y; return g0;
}


float minimize3(float & xo, float & yo, float & zo, float s, float g, float f(float, float, float))
{
  float  dx1,dy1,dz1,dx,dy,dz; int i=1;
  float  x=xo, y=yo, z=zo;
  float  g1, g0=f(x,y,z);
  vector N,u;

  TextWin.Output(1,"- Matching...\n");
  
  while(s>g){
	TextWin.Output(1,"  iteration %2d, stepsize %f -> mismatch = %f\n", i, s, g0);

    N = vector(float(cos(ea)*cos(aa)), float(sin(ea)),float( cos(ea)*sin(aa)));
    u = ((fabs(N.x)<OB64) && (fabs(N.y)<OB64))? vector(N.z, 0.0f, -N.x) : vector(-N.y, N.x, 0.0f);

    GraphWin.GScreen.V.Location = Cm;
	GraphWin.GScreen.V.Target   = Cm+unit(N)*distance(vector(0.0f, 0.0f, 0.0f), Cm);
	GraphWin.GScreen.V.Up       = ((const float)(cos(ua))*u - (const float)(sin(ua))*(N*u));
	GraphWin.GScreen.V.h        = Vh;
    GraphWin.InvalidateRect(NULL,FALSE); WaitTask(NULL);
    	
	dx1=f(x+0.1f*s,y,z)-f(x-0.1f*s,y,z);
    dy1=f(x,y+0.1f*s,z)-f(x,y-0.1f*s,z);
    dz1=f(x,y,z+0.1f*s)-f(x,y,z-0.1f*s);
    dx=float(-dx1/sqrt(dx1*dx1+dy1*dy1+dz1*dz1));
    dy=float(-dy1/sqrt(dx1*dx1+dy1*dy1+dz1*dz1));
    dz=float(-dz1/sqrt(dx1*dx1+dy1*dy1+dz1*dz1));
    if((g1=f(x+s*dx, y+s*dy, z+s*dz)) < g0){
	  x += s*dx;
	  y += s*dy;
	  z += s*dz;
	  g0=g1; Vh0=Vh; ua0=ua;
	} else {
	  s*=0.5f;
	} i++;
  }
  return g0;
}

int LSI(vector N, vector P, float l, float & t1, float & t2)
{
  matrix TM,Tb;
  TM.InitTransformation(l, l, l, 0.0f, 0.0f, 0.0f, P.x, P.y, P.z);
  Tb = TM.Inverse(); // calculate backtransformation matrix
  vector Ray=N*Tb-vector(Tb.M41, Tb.M42, Tb.M43);
  vector Org=vector(0.0f, 0.0f, 0.0f)*Tb;
  double a = Ray.x*Ray.x + Ray.y*Ray.y + Ray.z*Ray.z;
  double b = Ray.x*Org.x + Ray.y*Org.y + Ray.z*Org.z;
  double c = Org.x*Org.x + Org.y*Org.y + Org.z*Org.z - 1.0;
  double d = b*b-a*c;
  if(d>=0.0){
    if(d>0.0){
      t1 = (float)((-b - sqrt(d))/a);
      t2 = (float)((-b + sqrt(d))/a);
	  return 2;
    } else {
      t1 = (float)(-b/a);
	  t2 = (float)(-b/a);
      return 1;
	}
  }
  return 0;
}

vector T0,T1,T2;

float perval(vector V1, vector V2, vector P0, vector P1, vector P2)
{
  double  g;
float t1,t2,t3,t4;
  vector Ta,Tb;

  if(LSI(V1, T0, distance(P0,P1), t1, t2)){
    if(LSI(V2, T0, distance(P0,P2), t3, t4)){
	  Ta = t1*V1; Tb = t3*V2;
	  g  = fabs(distance(Ta,Tb)-distance(P1,P2)); T1=Ta; T2=Tb;
	  Ta = t1*V1; Tb = t4*V2;
	  if ( fabs(distance(Ta,Tb)-distance(P1,P2))<g){ g = fabs(distance(Ta,Tb)-distance(P1,P2)); T1=Ta; T2=Tb; }
	  Ta = t2*V1; Tb = t3*V2;
	  if ( fabs(distance(Ta,Tb)-distance(P1,P2))<g){ g = fabs(distance(Ta,Tb)-distance(P1,P2)); T1=Ta; T2=Tb; }
	  Ta = t2*V1; Tb = t4*V2;
	  if ( fabs(distance(Ta,Tb)-distance(P1,P2))<g){ g = fabs(distance(Ta,Tb)-distance(P1,P2)); T1=Ta; T2=Tb; }
    } else g=0.6f;
  } else g=0.6f;
  return float(g);
}

float CalcQVhd(float d, float Vh)
{
  float  b  = Vh/2.0f;
  float  bx = XRes<YRes? b : b*((float)XRes/(float)YRes)    ;
  float  by = XRes<YRes?     b*((float)YRes/(float)XRes) : b;

  vector VPorg = vector(-bx, -by, -1.0f);

  vector V0 = unit(VPorg + vector(S1[0].x*(2.0f/(float)XRes*bx), S1[0].y/(float)YRes*2.0f*by, 0.0f));
  vector V1 = unit(VPorg + vector(S1[1].x*(2.0f/(float)XRes*bx), S1[1].y/(float)YRes*2.0f*by, 0.0f));
  vector V2 = unit(VPorg + vector(S1[2].x*(2.0f/(float)XRes*bx), S1[2].y/(float)YRes*2.0f*by, 0.0f));
	  
  T0=d*V0; return perval(V1, V2, P1[0], P1[1], P1[2]);
}

vector RProj(vector P, matrix E, float Vh, float XRes, float YRes)
{
  vector S,T=P*E;
  S.x = (0.5f*XRes) + T.x / (T.z*0.5f*Vh) * (0.5f*YRes);
  S.y = (0.5f*YRes) + T.y / (T.z*0.5f*Vh) * (0.5f*YRes);
  S.z =  0.0f;
  return S;
}

void MakMat(vector Cm, vector N, vector U, vector V, matrix *E)
{
  matrix T,B;
  
  T.M11=1.0f; T.M21=0.0f; T.M31=0.0f; T.M41=-Cm.x;
  T.M12=0.0f; T.M22=1.0f; T.M32=0.0f; T.M42=-Cm.y;
  T.M13=0.0f; T.M23=0.0f; T.M33=1.0f; T.M43=-Cm.z;

  B.M11=U.x;  B.M21=U.y;  B.M31=U.z;  B.M41=0.0f;
  B.M12=V.x;  B.M22=V.y;  B.M32=V.z;  B.M42=0.0f;
  B.M13=N.x;  B.M23=N.y;  B.M33=N.z;  B.M43=0.0f;

  *E = T * B;
}

void SetViewVhd(float Vh1, float d, vector *cam, vector *tgt, vector *upp)
{
  CalcQVhd(d,Vh1);
  
  vector l1 = unit(P1[1]-P1[0]);

  vector ax = unit(l1 *     (T1-T0));
  float  an = float(acos(l1 % unit(T1-T0)));

  matrix ct;  ct.InitTransformation(1.0f, 1.0f, 1.0f, 0.0f, 0.0f, 0.0f, P1[0].x-T0.x, P1[0].y-T0.y, P1[0].z-T0.z);
  
         ct = ct * InitAxisRot(P1[0].x, P1[0].y, P1[0].z, ax.x, ax.y, ax.z, an);
  
  vector s1 = unit(l1*(P1[2]-P1[0]));
  vector s2 = unit(l1*(T2*ct-P1[0]));

  vector nv = s1 * s2;
  an = float(acos(s1 % s2)); 
  if((nv % l1) < 0.0f) an = -an;

         ct = ct * InitAxisRot(P1[0].x, P1[0].y, P1[0].z, l1.x, l1.y, l1.z, an);

  *cam =      vector(0.0f, 0.0f,  0.0f) * ct;
  *tgt = unit(vector(0.0f, 0.0f, -1.0f) * ct - *cam) * distance(*cam, (P1[0]+P1[1]+P1[2])/3.0f) + *cam;
  *upp = unit(vector(0.0f, 1.0f,  0.0f) * ct - *cam);
}

float CalcQ_SI(void)
{
  vector S2[9];
  vector VPorg;
  float bx,by,g=0.0f;
  
  vector N = vector(float(cos(ea)*cos(aa)),float( sin(ea)),float( cos(ea)*sin(aa)));

  vector u  = unit(((fabs(N.x)<OB64) && (fabs(N.y)<OB64))? vector(N.z, 0.0f, -N.x) : vector(-N.y, N.x, 0.0f));
  vector Up = (const float)(cos(ua))*u - (const float)(sin(ua))*(N*u);
  
  vector V  = unit(Up-(Up%N)*N);
  vector U  = N*V;

  bx = Vh*(XRes/YRes); by = Vh;
  VPorg = Cm + N - bx*U - by*V;

  matrix E; MakMat(Cm, N, U, V, &E);

  for(int i=0; i<nlv; i++){
    S2[i] = RProj(P1[i], E, Vh, XRes, YRes);
    g += float( sqrt(sqr(S2[i].x-S1[i].x)+sqr(S2[i].y-S1[i].y)));
  }

  qcc++; return sqr(g);
}

float CalcVQ(vector Cam, vector Tgt, vector Upp, float Vhh)
{
  vector S2[9];
  float g=0.0f;
  
  vector N = unit(Tgt-Cam);
  vector V = unit(Upp-(Upp%N)*N);
  vector U = N*V;

  matrix E; MakMat(Cam, N, U, V, &E);

  for(int i=0; i<nlv; i++){
    S2[i] = RProj(P1[i], E, Vhh, XRes, YRes);
    g += (sqr(S2[i].x-S1[i].x)+sqr(S2[i].y-S1[i].y));
  }

  return g;
}

extern float CalcDistVL2D(float x1, float y1, float x2, float y2, float xs, float ys, float *xl, float *yl);

float CalcVQ2(vector Cam, float aa, float ea, float ua, float Vh)
{
  vector S2[9];
  float g=0.0f;
  
  vector N = vector(float(cos(ea)*cos(aa)), float(sin(ea)), float(cos(ea)*sin(aa)));
  vector u = unit(((fabs(N.x)<OB64) && (fabs(N.y)<OB64))? vector(N.z, 0.0f, -N.x) : vector(-N.y, N.x, 0.0f));

  vector Upp = (const float)(cos(ua))*u + (const float)(sin(ua))*(N*u);

  vector V = unit(Upp-(Upp%N)*N);
  vector U = N*V;

  matrix E; MakMat(Cam, N, U, V, &E);

  for(int i=0; i<nlv; i++){
	if(eg[i]){
	  vector L1 = RProj(P1[i], E, Vh, XRes, YRes);
      vector L2 = RProj(P2[i], E, Vh, XRes, YRes);
	  vector LP;
	  g += CalcDistVL2D(L1.x,L1.y, L2.x,L2.y, S1[i].x, S1[i].y, &(LP.x), &(LP.y));
    } else {
      S2[i] = RProj(P1[i], E, Vh, XRes, YRes);
      g += (sqr(S2[i].x-S1[i].x)+sqr(S2[i].y-S1[i].y));
	}
  }

  return g;
}

float Check_vu(float x, float y)
{
  Vh=x; ua=y; return CalcQ_SI();
}

float Min_N(float x, float y)
{
  aa=x; ea=y; Vh=Vh0; ua=ua0;
  return minimize2(Vh, ua, 0.01f, 0.0001f, &Check_vu);
}

float Min_C(float x, float y, float z)
{
  Cm=vector(x,y,z); vector Tg = vector(0.0f, 0.0f, 0.0f); vector N = unit(Tg - Cm);
  aa = ((fabs(N.x)>0.001)? float(atan(N.z/N.x)) : Pi_2) + ((N.x<0.0)? Pi : 0.0f); 
  if(aa<0.0) aa+=TwoPi;
  ea = float(asin(N.y));
  return minimize2(aa, ea, 0.005f, 0.0001f, &Min_N);
}
 
float g_d;

float Calc_d(float Vh){
  float iq,cq; float s=0.05f; g_d=0.2f;
  while(s>0.0001f){
    iq=CalcQVhd(g_d,Vh);
	do{
	  cq=iq; g_d+=s; iq=CalcQVhd(g_d,Vh);
	} while((g_d<15.0f) && (iq<cq));
	g_d-=1.5f*s; s*=0.1f;
  }
  g_d+=5.0f*s;
  vector cam, tgt, upp;
  SetViewVhd(Vh, g_d, &cam, &tgt, &upp);
  return CalcVQ(cam, tgt, upp, Vh);
}

long FAR PASCAL WndProc (HWND, UINT, UINT, LONG);
long FAR PASCAL TexProc (HWND, UINT, UINT, LONG);
BITMAPINFO  BMPinfoB;
BITMAPINFO  BMPinfo1;
BITMAPINFO  BMPinfo2;
byte       *BMPbitsB=NULL;
byte       *BMPbits1;
byte       *BMPbits2;
CMenu       menu;
CMenu      *pPopup;
CMenu       TexMenu;
CMenu      *pTexPopup;
HWND        ViewWin;
HWND        TexWin;

byte *LoadDEMFile(char *filename, BITMAPINFO *BMPinfo)
{
  FILE *demfile;
  byte *BMPbits=NULL;
  byte *bitptr;
  unsigned short int depth;
  int   width,height;
  int   x,y;

  demfile = fopen(filename,"rb");
  if(demfile){
    width =800;
    height=600;

    BMPinfo->bmiHeader.biSize          = sizeof(BITMAPINFOHEADER);
    BMPinfo->bmiHeader.biWidth         = width;
    BMPinfo->bmiHeader.biHeight        = height;
    BMPinfo->bmiHeader.biPlanes        = 1;
    BMPinfo->bmiHeader.biBitCount      = 24;
    BMPinfo->bmiHeader.biSizeImage     = height*((width*3+3) & 0xFFFFFFFC);
    BMPinfo->bmiHeader.biXPelsPerMeter = 0;
    BMPinfo->bmiHeader.biYPelsPerMeter = 0;
    BMPinfo->bmiHeader.biClrUsed       = 0;
    BMPinfo->bmiHeader.biClrImportant  = 0;

    BMPbits = (byte *)malloc(BMPinfo->bmiHeader.biSizeImage);

    fread(&depth,1,1,demfile);
	for(x=0; x<400; x++){
      fread(&depth,1,2,demfile);
	}
	for(y=0; y<height; y++){
      bitptr=BMPbits+(y*((width*3+3) & 0xFFFFFFFC));
	  for(x=0; x<width; x++){
        fread(&depth,1,2,demfile);
        bitptr[3*x  ]=(byte)(depth>>4);
		bitptr[3*x+1]=(byte)(depth>>4);
		bitptr[3*x+2]=(byte)(depth>>4);
	  }
	  for(x=0; x<(989-width); x++){
        fread(&depth,1,2,demfile);
	  }
      fread(&depth,1,1,demfile);
	}

    fclose(demfile);
  }
  return BMPbits;
}

void OpenBackground()
{
  OPENFILENAME  OFName;
  OFName.lStructSize = sizeof(OPENFILENAME);
  OFName.hwndOwner = NULL;
  OFName.lpstrCustomFilter = NULL;
  OFName.nFilterIndex = 1;
  OFName.lpstrFile = phfilename;
  OFName.nMaxFile = sizeof(phfilename);
  OFName.lpstrFileTitle = NULL;
  OFName.lpstrInitialDir = NULL;
  OFName.lpstrTitle = NULL;
  OFName.Flags = 0;
  OFName.nFileOffset = 0;
  OFName.nFileExtension = 0;
  OFName.lpfnHook = NULL;
  OFName.lpstrFilter = "Bitmap files  (*.BMP)\000*.bmp\000JPEG files  (*.JPG)\000*.jpg\000GIF files  (*.GIF)\000*.gif\000All Files  (*.*)\000*.*\000\000";
  OFName.lpstrDefExt = "BMP";
  if(!GetOpenFileName(&OFName)) phfilename[0]=0;
  if(phfilename[0]){
    if(BMPbitsB=LoadImageFile(phfilename, &BMPinfoB)) GraphWin.InvalidateRect(NULL,FALSE);
    XRes=(float)BMPinfoB.bmiHeader.biWidth; YRes=(float)BMPinfoB.bmiHeader.biHeight;
  }
}


void OpenPhoto()
{
  OPENFILENAME  OFName;
  OFName.lStructSize = sizeof(OPENFILENAME);
  OFName.hwndOwner = NULL;
  OFName.lpstrCustomFilter = NULL;
  OFName.nFilterIndex = 1;
  OFName.lpstrFile = phfilename;
  OFName.nMaxFile = sizeof(phfilename);
  OFName.lpstrFileTitle = NULL;
  OFName.lpstrInitialDir = NULL;
  OFName.lpstrTitle = NULL;
  OFName.Flags = 0;
  OFName.nFileOffset = 0;
  OFName.nFileExtension = 0;
  OFName.lpfnHook = NULL;
  OFName.lpstrFilter = "Bitmap files  (*.BMP)\000*.bmp\000JPEG files  (*.JPG)\000*.jpg\000GIF files  (*.GIF)\000*.gif\000All Files  (*.*)\000*.*\000\000";
  OFName.lpstrDefExt = "BMP";
  if(!GetOpenFileName(&OFName)) phfilename[0]=0;
  if(phfilename[0]){
    BMPbits1=LoadImageFile(phfilename, &BMPinfo1);
    //BMPbits1=LoadDEMFile(phfilename, &BMPinfo1);
    
	int       width,height;
    WNDCLASS  wndclass;

    wndclass.style         = CS_HREDRAW | CS_VREDRAW;
    wndclass.lpfnWndProc   = WndProc;
    wndclass.cbClsExtra    = 0;
    wndclass.cbWndExtra    = 0;
    wndclass.hInstance     = AfxGetInstanceHandle();
    wndclass.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
    wndclass.hCursor       = LoadCursor(NULL, IDC_CROSS);
    wndclass.hbrBackground = (struct HBRUSH__ *)GetStockObject(WHITE_BRUSH);
    wndclass.lpszMenuName  = NULL;
    wndclass.lpszClassName = "VModel";
    RegisterClass(&wndclass);

    ViewWin = CreateWindow ("VModel",                        // Fensterklassenname
                            "Test",                          // Titelleiste
                            WS_OVERLAPPEDWINDOW,             // Fensterstil
                            GetSystemMetrics(SM_CXSCREEN)/4, // Fensterposition, x
                            GetSystemMetrics(SM_CYSCREEN)/4, // Fensterposition, y
                            GetSystemMetrics(SM_CXSCREEN)/2, // horizontale Gre
                            GetSystemMetrics(SM_CYSCREEN)/2, // vertikale Gre
                            NULL,                            // Handle Parent-Window
                            NULL,                            // Handle Men
                            AfxGetInstanceHandle(),                           // Handle Programmkopie
                            NULL); pt[3].x=-1.0f;                           // Spezialparameter


    if(BMPinfo1.bmiHeader.biHeight<680){
      width =BMPinfo1.bmiHeader.biWidth +2*GetSystemMetrics(SM_CXFRAME);
      height=BMPinfo1.bmiHeader.biHeight+2*GetSystemMetrics(SM_CYFRAME)+GetSystemMetrics(SM_CYCAPTION)-1;
    } else {
      width =680*BMPinfo1.bmiHeader.biWidth/BMPinfo1.bmiHeader.biHeight +2*GetSystemMetrics(SM_CXFRAME);
      height=680+2*GetSystemMetrics(SM_CYFRAME)+GetSystemMetrics(SM_CYCAPTION)-1;
    }
    MoveWindow  (ViewWin,(GetSystemMetrics(SM_CXSCREEN)-width)/2,(GetSystemMetrics(SM_CYSCREEN)-height)/2,width,height+1,FALSE);
    ShowWindow  (ViewWin,SW_SHOW);
    UpdateWindow(ViewWin);

    VERIFY(menu.LoadMenu(IDR_MENU1));
    pPopup = menu.GetSubMenu(0);
    ASSERT(pPopup != NULL);
  }
}

long FAR PASCAL WndProc (HWND WinHd, UINT message, UINT wParam, LONG lParam)
{
  HDC          hdc;
  PAINTSTRUCT  ps;
  vector       mp;
  RECT         rect;
  int          OldROP;
  static POINT mnp,wp;
  static int   mode=0;
  static BOOL  OldLine=FALSE;
  HPEN         OldPen,NewPen;

  switch(message){
    case WM_PAINT:
      hdc=BeginPaint(WinHd, &ps);
      GetClientRect(WinHd,&rect);
	  fx=(float)rect.right /(float)BMPinfo1.bmiHeader.biWidth;
	  fy=(float)rect.bottom/(float)BMPinfo1.bmiHeader.biHeight;
	  StretchDIBits(hdc, 0, 0, rect.right, rect.bottom, 0, 0, BMPinfo1.bmiHeader.biWidth, BMPinfo1.bmiHeader.biHeight, BMPbits1, &BMPinfo1, DIB_RGB_COLORS, SRCCOPY);
      if(pt[3].x>=0.0f){
        NewPen=CreatePen(PS_SOLID,1,0x0000F000);
        OldPen=(HPEN)SelectObject(hdc,NewPen);
        MoveToEx(hdc,(int)(fx*pt[0].x+0.5f),(int)(fy*pt[0].y+0.5f),NULL); LineTo(hdc,(int)(fx*pt[1].x+0.5f),(int)(fy*pt[1].y+0.5f));
        MoveToEx(hdc,(int)(fx*pt[1].x+0.5f),(int)(fy*pt[1].y+0.5f),NULL); LineTo(hdc,(int)(fx*pt[2].x+0.5f),(int)(fy*pt[2].y+0.5f));
        MoveToEx(hdc,(int)(fx*pt[2].x+0.5f),(int)(fy*pt[2].y+0.5f),NULL); LineTo(hdc,(int)(fx*pt[3].x+0.5f),(int)(fy*pt[3].y+0.5f));
        MoveToEx(hdc,(int)(fx*pt[3].x+0.5f),(int)(fy*pt[3].y+0.5f),NULL); LineTo(hdc,(int)(fx*pt[0].x+0.5f),(int)(fy*pt[0].y+0.5f));
        SelectObject(hdc,OldPen);
        DeleteObject(NewPen);
	  }
	  EndPaint(WinHd,&ps);
      return 0;
    case WM_ERASEBKGND:
	  return 0;
    case WM_MOVE:
      wp.x=LOWORD(lParam);
      wp.y=HIWORD(lParam);
      return 0;
    case WM_LBUTTONDOWN:
	  switch(mode){
	    case 1:
          pt[0].x=(float)LOWORD(lParam)/fx; pt[0].y=(float)HIWORD(lParam)/fy;
		  mode=2; break;
	    case 2:
          hdc=GetDC(ViewWin); OldROP=SetROP2(hdc,R2_NOT);
          mp=pt[1]; pt[1].x=(float)LOWORD(lParam)/fx; pt[1].y=(float)HIWORD(lParam)/fy;
          if(OldLine){
            MoveToEx(hdc,(int)(fx*pt[0].x+0.5f),(int)(fy*pt[0].y+0.5f),NULL); LineTo(hdc,(int)(fx*mp.x+0.5f),(int)(fy*mp.y+0.5f)); OldLine=FALSE;
          }
          SetROP2(hdc,OldROP);
          NewPen=CreatePen(PS_SOLID,1,0x0000F000);
          OldPen=(HPEN)SelectObject(hdc,NewPen);
          MoveToEx(hdc,(int)(fx*pt[0].x+0.5f),(int)(fy*pt[0].y+0.5f),NULL); LineTo(hdc,(int)(fx*pt[1].x+0.5f),(int)(fy*pt[1].y+0.5f));
          SelectObject(hdc,OldPen);
          DeleteObject(NewPen);
		  ReleaseDC(ViewWin,hdc);
		  mode=3; break;
	    case 3:
          hdc=GetDC(ViewWin); OldROP=SetROP2(hdc,R2_NOT);
          mp=pt[2]; pt[2].x=(float)LOWORD(lParam)/fx; pt[2].y=(float)HIWORD(lParam)/fy;
          if(OldLine){
            MoveToEx(hdc,(int)(fx*pt[0].x+0.5f),(int)(fy*pt[0].y+0.5f),NULL); LineTo(hdc,(int)(fx*mp.x+0.5f),(int)(fy*mp.y+0.5f));
            MoveToEx(hdc,(int)(fx*pt[1].x+0.5f),(int)(fy*pt[1].y+0.5f),NULL); LineTo(hdc,(int)(fx*mp.x+0.5f),(int)(fy*mp.y+0.5f)); OldLine=FALSE;
          }
	      SetROP2(hdc,OldROP);
          NewPen=CreatePen(PS_SOLID,1,0x0000F000);
          OldPen=(HPEN)SelectObject(hdc,NewPen);
          MoveToEx(hdc,(int)(fx*pt[1].x+0.5f),(int)(fy*pt[1].y+0.5f),NULL); LineTo(hdc,(int)(fx*pt[2].x+0.5f),(int)(fy*pt[2].y+0.5f));
          SelectObject(hdc,OldPen);
          DeleteObject(NewPen);
		  ReleaseDC(ViewWin,hdc);
	      mode=4; break;
	    case 4:
          hdc=GetDC(ViewWin); OldROP=SetROP2(hdc,R2_NOT);
          mp=pt[3]; pt[3].x=(float)LOWORD(lParam)/fx; pt[3].y=(float)HIWORD(lParam)/fy;
          if(OldLine){
            MoveToEx(hdc,(int)(fx*pt[0].x+0.5f),(int)(fy*pt[0].y+0.5f),NULL); LineTo(hdc,(int)(fx*mp.x+0.5f),(int)(fy*mp.y+0.5f));
            MoveToEx(hdc,(int)(fx*pt[2].x+0.5f),(int)(fy*pt[2].y+0.5f),NULL); LineTo(hdc,(int)(fx*mp.x+0.5f),(int)(fy*mp.y+0.5f)); OldLine=FALSE;
          }
	      SetROP2(hdc,OldROP);
          NewPen=CreatePen(PS_SOLID,1,0x0000F000);
          OldPen=(HPEN)SelectObject(hdc,NewPen);
          MoveToEx(hdc,(int)(fx*pt[0].x+0.5f),(int)(fy*pt[0].y+0.5f),NULL); LineTo(hdc,(int)(fx*pt[3].x+0.5f),(int)(fy*pt[3].y+0.5f));
          MoveToEx(hdc,(int)(fx*pt[2].x+0.5f),(int)(fy*pt[2].y+0.5f),NULL); LineTo(hdc,(int)(fx*pt[3].x+0.5f),(int)(fy*pt[3].y+0.5f));
          SelectObject(hdc,OldPen);
          DeleteObject(NewPen);
		  ReleaseDC(ViewWin,hdc);
		  mode=0; break;
      }
      return 0;
    case WM_MOUSEMOVE:
      switch(mode){
        case 2:
          hdc=GetDC(ViewWin); OldROP=SetROP2(hdc,R2_NOT);
          mp=pt[1]; pt[1].x=(float)LOWORD(lParam)/fx; pt[1].y=(float)HIWORD(lParam)/fy;
          if(OldLine){
            MoveToEx(hdc,(int)(fx*pt[0].x+0.5f),(int)(fy*pt[0].y+0.5f),NULL); LineTo(hdc,(int)(fx*mp.x+0.5f),(int)(fy*mp.y+0.5f)); OldLine=FALSE;
          }
          MoveToEx(hdc,(int)(fx*pt[0].x+0.5f),(int)(fy*pt[0].y+0.5f),NULL); LineTo(hdc,(int)(fx*pt[1].x+0.5f),(int)(fy*pt[1].y+0.5f)); OldLine=TRUE;
          SetROP2(hdc,OldROP); ReleaseDC(ViewWin,hdc);
          break;
        case 3:
          hdc=GetDC(ViewWin); OldROP=SetROP2(hdc,R2_NOT);
          mp=pt[2]; pt[2].x=(float)LOWORD(lParam)/fx; pt[2].y=(float)HIWORD(lParam)/fy;
          if(OldLine){
            MoveToEx(hdc,(int)(fx*pt[0].x+0.5f),(int)(fy*pt[0].y+0.5f),NULL); LineTo(hdc,(int)(fx*mp.x+0.5f),(int)(fy*mp.y+0.5f));
            MoveToEx(hdc,(int)(fx*pt[1].x+0.5f),(int)(fy*pt[1].y+0.5f),NULL); LineTo(hdc,(int)(fx*mp.x+0.5f),(int)(fy*mp.y+0.5f)); OldLine=FALSE;
          }
          MoveToEx(hdc,(int)(fx*pt[0].x+0.5f),(int)(fy*pt[0].y+0.5f),NULL); LineTo(hdc,(int)(fx*pt[2].x+0.5f),(int)(fy*pt[2].y+0.5f));
          MoveToEx(hdc,(int)(fx*pt[1].x+0.5f),(int)(fy*pt[1].y+0.5f),NULL); LineTo(hdc,(int)(fx*pt[2].x+0.5f),(int)(fy*pt[2].y+0.5f)); OldLine=TRUE;
          SetROP2(hdc,OldROP); ReleaseDC(ViewWin,hdc);
          break;
        case 4:
          hdc=GetDC(ViewWin); OldROP=SetROP2(hdc,R2_NOT);
          mp=pt[3]; pt[3].x=(float)LOWORD(lParam)/fx; pt[3].y=(float)HIWORD(lParam)/fy;
          if(OldLine){
            MoveToEx(hdc,(int)(fx*pt[0].x+0.5f),(int)(fy*pt[0].y+0.5f),NULL); LineTo(hdc,(int)(fx*mp.x+0.5f),(int)(fy*mp.y+0.5f));
            MoveToEx(hdc,(int)(fx*pt[2].x+0.5f),(int)(fy*pt[2].y+0.5f),NULL); LineTo(hdc,(int)(fx*mp.x+0.5f),(int)(fy*mp.y+0.5f)); OldLine=FALSE;
          }
          MoveToEx(hdc,(int)(fx*pt[0].x+0.5f),(int)(fy*pt[0].y+0.5f),NULL); LineTo(hdc,(int)(fx*pt[3].x+0.5f),(int)(fy*pt[3].y+0.5f));
          MoveToEx(hdc,(int)(fx*pt[2].x+0.5f),(int)(fy*pt[2].y+0.5f),NULL); LineTo(hdc,(int)(fx*pt[3].x+0.5f),(int)(fy*pt[3].y+0.5f)); OldLine=TRUE;
          SetROP2(hdc,OldROP); ReleaseDC(ViewWin,hdc);
          break;
	  }
	  return 0;
    case WM_RBUTTONDOWN:
      mnp.x=LOWORD(lParam);
      mnp.y=HIWORD(lParam);
      TrackPopupMenu(pPopup->m_hMenu,TPM_LEFTALIGN | TPM_RIGHTBUTTON, wp.x+mnp.x, wp.y+mnp.y, 0, ViewWin, NULL);
      return 0;
    case WM_COMMAND:
      switch(wParam){
        case ID_VZoom:    CloseWindow(ViewWin); break;
        case ID_VPan:     CloseWindow(ViewWin); break;
        case ID_VQuad:    mode=1; break;
        case ID_VStretch: CloseWindow(ViewWin); break;
        case ID_VGetTex:  GetTex2D(); break;
      }
      return 0;
  }
  return DefWindowProc(WinHd, message, wParam, lParam);
}


long FAR PASCAL TexProc (HWND WinHd, UINT message, UINT wParam, LONG lParam)
{
  HDC          hdc;
  PAINTSTRUCT  ps;
  RECT         rect;
  POINT        mp;
  static POINT wp;

  switch(message){
    case WM_PAINT:
      hdc=BeginPaint(WinHd, &ps);
      GetClientRect(WinHd,&rect);
	  StretchDIBits(hdc, 0, 0, rect.right, rect.bottom, 0, 0, BMPinfo2.bmiHeader.biWidth, BMPinfo2.bmiHeader.biHeight, BMPbits2, &BMPinfo2, DIB_RGB_COLORS, SRCCOPY);
      EndPaint(WinHd,&ps);
      return 0;
    case WM_MOVE:
      wp.x=LOWORD(lParam);
      wp.y=HIWORD(lParam);
      return 0;
    case WM_ERASEBKGND:
	  return 0;
    case WM_RBUTTONDOWN:
      mp.x=LOWORD(lParam);
      mp.y=HIWORD(lParam);
      TrackPopupMenu(pTexPopup->m_hMenu, TPM_LEFTALIGN | TPM_RIGHTBUTTON, wp.x+mp.x, wp.y+mp.y, 0, TexWin, NULL);
      return 0;
    case WM_COMMAND:
      switch(wParam){
        case ID_TexSave: SaveBitMap(NULL, &BMPinfo2, BMPbits2); break;
        case ID_TexCopy: CopyBitMap(&BMPinfo2, BMPbits2); break;
        case ID_TexExit: DestroyWindow(TexWin); break;
      }
      return 0;
  }
  return DefWindowProc(WinHd, message, wParam, lParam);
}

void MatchCam2()
{
  vector V,N,u;

  if(VMDoc->VLList){
	VLPtr vl = VMDoc->VLList; nlv=0;
	while(vl){
	  P1[nlv] = vl->pg;
	  if(eg[nlv] = (vl->edg)) P2[nlv] = vl->pe;
	  S1[nlv] = vl->pp; S1[nlv].y = YRes-1.0f-S1[nlv].y;
	  vl = vl->next; nlv++;
	}
  
    Cm = GraphWin.GScreen.V.Location;
    N  = unit(GraphWin.GScreen.V.Target - GraphWin.GScreen.V.Location);
    V  = unit(GraphWin.GScreen.V.Up-(GraphWin.GScreen.V.Up%N)*N);
    u  = unit(((fabs(N.x)<OB64) && (fabs(N.y)<OB64))? vector(N.z, 0.0f, -N.x) : vector(-N.y, N.x, 0.0f));
    aa = ((fabs(N.x)>0.001)? float(atan(N.z/N.x)) : Pi_2) + ((N.x<0.0)? Pi : 0.0f); if(aa<0.0) aa+=TwoPi;
    ea = float(asin(N.y));
    ua = float(acos(V % u));
	if((V % (N*u))<0.0f) ua+=3.1415962f;
	float Vh=GraphWin.GScreen.V.h;
    float dvl,dVh1,dVh,dua1,dua,dea1,dea,daa1,daa,dcz1,dcz,dcy1,dcy,dcx1,dcx;
    float s=0.01f;
	float g=0.0001f;
	int   c=0,i=1;

    float g1,g0=CalcVQ2(Cm, aa, ea, ua, Vh);
	while(s>g){
	  if(c>=(i/10)){
	    TextWin.Output(1,"  iteration %2d, stepsize %f -> mismatch = %f\n", i, s, g0);
        N  = vector(float(cos(ea)*cos(aa)), float(sin(ea)), float(cos(ea)*sin(aa)));
        u  = unit(((fabs(N.x)<OB64) && (fabs(N.y)<OB64))? vector(N.z, 0.0f, -N.x) : vector(-N.y, N.x, 0.0f));
	    GraphWin.GScreen.V.Location = Cm;
	    GraphWin.GScreen.V.Target   = Cm+unit(N)*distance(vector(0.0f, 0.0f, 0.0f), Cm);
	    GraphWin.GScreen.V.Up       = (const float)(cos(ua))*u + (const float)(sin(ua))*(N*u);
	    GraphWin.GScreen.V.h        = Vh;
        GraphWin.InvalidateRect(NULL,FALSE); WaitTask(NULL); c=0;
	  } c++;

	  dVh1=CalcVQ2(vector(Cm.x, Cm.y, Cm.z), aa, ea, ua, Vh+0.1f*s)-CalcVQ2(vector(Cm.x, Cm.y, Cm.z), aa, ea, ua, Vh-0.1f*s);
	  dua1=CalcVQ2(vector(Cm.x, Cm.y, Cm.z), aa, ea, ua+0.1f*s, Vh)-CalcVQ2(vector(Cm.x, Cm.y, Cm.z), aa, ea, ua-0.1f*s, Vh);
	  dea1=CalcVQ2(vector(Cm.x, Cm.y, Cm.z), aa, ea+0.1f*s, ua, Vh)-CalcVQ2(vector(Cm.x, Cm.y, Cm.z), aa, ea-0.1f*s, ua, Vh);
	  daa1=CalcVQ2(vector(Cm.x, Cm.y, Cm.z), aa+0.1f*s, ea, ua, Vh)-CalcVQ2(vector(Cm.x, Cm.y, Cm.z), aa-0.1f*s, ea, ua, Vh);
	  dcz1=CalcVQ2(vector(Cm.x, Cm.y, Cm.z+0.1f*s), aa, ea, ua, Vh)-CalcVQ2(vector(Cm.x, Cm.y, Cm.z-0.1f*s), aa, ea, ua, Vh);
	  dcy1=CalcVQ2(vector(Cm.x, Cm.y+0.1f*s, Cm.z), aa, ea, ua, Vh)-CalcVQ2(vector(Cm.x, Cm.y-0.1f*s, Cm.z), aa, ea, ua, Vh);
	  dcx1=CalcVQ2(vector(Cm.x+0.1f*s, Cm.y, Cm.z), aa, ea, ua, Vh)-CalcVQ2(vector(Cm.x-0.1f*s, Cm.y, Cm.z), aa, ea, ua, Vh);
      dvl= float(sqrt(dVh1*dVh1 + dua1*dua1 + dea1*dea1 + daa1*daa1 + dcz1*dcz1 + dcy1*dcy1 + dcx1*dcx1));
	  dVh=-dVh1/dvl;
      dua=-dua1/dvl;
      dea=-dea1/dvl;
      daa=-daa1/dvl;
      dcz=-dcz1/dvl;
      dcy=-dcy1/dvl;
      dcx=-dcx1/dvl;
      if((g1=CalcVQ2(vector(Cm.x+s*dcx, Cm.y+s*dcy, Cm.z+s*dcz), aa+s*daa, ea+s*dea, ua+s*dua, Vh+s*dVh)) < g0){
	    Vh += s*dVh;
	    ua += s*dua;
	    ea += s*dea;
	    aa += s*daa;
	    Cm += s*vector(dcx,dcy,dcz);
	    g0=g1;
	  } else {
	    s*=0.5f;
	  } i++;
	}

	TextWin.Output(1,"  iteration %2d, stepsize %f -> mismatch = %f\n", i, s, g0);
    N  = vector(float(cos(ea)*cos(aa)), float(sin(ea)),float( cos(ea)*sin(aa)));
    u  = unit(((fabs(N.x)<OB64) && (fabs(N.y)<OB64))? vector(N.z, 0.0f, -N.x) : vector(-N.y, N.x, 0.0f));
	GraphWin.GScreen.V.Location = Cm;
	GraphWin.GScreen.V.Target   = Cm+unit(N)*distance(vector(0.0f, 0.0f, 0.0f), Cm);
	GraphWin.GScreen.V.Up       = (const float)(cos(ua))*u + (const float)(sin(ua))*(N*u);
	GraphWin.GScreen.V.h        = Vh;
    GraphWin.InvalidateRect(NULL,FALSE); WaitTask(NULL);

	//TextWin.Output(1,"  mismatch = %f\n", CalcVQ2(GraphWin.GScreen.V.Location, aa, ea, ua, GraphWin.GScreen.V.h));
    /*FILE   *outfile;

    outfile = fopen("C:\\TEMP\\SURF.VMD", "wt");
    fprintf(outfile,"VMODEL VERSION 0.60\n\n");
    fprintf(outfile,"OBJECT: Camera-Matching-Function\n");
    fprintf(outfile,"AUTHOR: VModel\n\n");
    fprintf(outfile,"Settings {\n");
    fprintf(outfile,"  BACKGROUND  0.0, 0.0, 0.0\n");
    fprintf(outfile,"  AMBIENT     0.3, 0.3, 0.3\n");
    fprintf(outfile,"}\n\n");
    fprintf(outfile,"View {\n");
    fprintf(outfile,"  Camera  20, 20, 10\n");
    fprintf(outfile,"  Target   5,  5,  0\n");
    fprintf(outfile,"  Up       0,  0,  1\n");
    fprintf(outfile,"  FoVAng  30\n");
    fprintf(outfile,"}\n\n");
    fprintf(outfile,"Material default {\n");
    fprintf(outfile,"  Reflection  RGB(0.7, 0.6, 0.5)\n");
    fprintf(outfile,"  Specularity 0.3, Exponent 20, Phong\n");
    fprintf(outfile,"}\n\n");
    fprintf(outfile,"PolyMesh Surface {\n");
    fprintf(outfile,"  doublesided, rounded\n");
	fprintf(outfile,"  Material default\n");
	fprintf(outfile,"  Points %d\n",40*40);
	int x,y;
	for(x=0; x<40; x++){
	  for(y=0; y<40; y++){
        fprintf(outfile,"    %f, %f, %f\n", (float)x, (float)y, 0.001f*CalcVQ2(GraphWin.GScreen.V.Location, aa-0.2+0.01*x, ea-0.2+0.01*y, ua, GraphWin.GScreen.V.h));
	  }
	}
    fprintf(outfile,"  Faces %d\n",39*39);
	for(x=0; x<39; x++){
	  for(y=0; y<39; y++){
        fprintf(outfile,"    4  %3d, %3d, %3d, %3d\n", 40*x+y, 40*x+y+1, 40*(x+1)+y+1, 40*(x+1)+y);
	  }
	}
    fprintf(outfile,"}\n");
    fclose(outfile);*/

    /*N  = vector(cos(ea)*cos(aa), sin(ea), cos(ea)*sin(aa));
	GraphWin.GScreen.V.Target   = Cm+unit(N)*distance(vector(0.0f, 0.0f, 0.0f), Cm);
	GraphWin.GScreen.V.Up       = cos(ua)*u + sin(ua)*(N*u);
    GraphWin.InvalidateRect(NULL,FALSE); WaitTask(NULL);*/
  }
}

void MatchCam1()
{
  if(VMDoc->VLList){
	VLPtr vl = VMDoc->VLList; nlv=0;
	while(vl){
	  P1[nlv] = vl->pg;
	  S1[nlv] = vl->pp; S1[nlv].y = YRes-1.0f-S1[nlv].y;
	  vl = vl->next; nlv++;
	}
  
    float cx=GraphWin.GScreen.V.Location.x;
    float cy=GraphWin.GScreen.V.Location.y;
    float cz=GraphWin.GScreen.V.Location.z;
    float le=distance(GraphWin.GScreen.V.Location, GraphWin.GScreen.V.Target);
    Vh0=GraphWin.GScreen.V.h; ua0=0.0f;
    minimize3(cx, cy, cz, 0.1f*le, 0.001f*le, &Min_C);
  }
}

void MatchVhd()
{
  if(VMDoc->VLList){
	VLPtr vl = VMDoc->VLList; nlv=0;
	while(vl){
	  P1[nlv] = vl->pg;
	  S1[nlv] = vl->pp; S1[nlv].y = YRes-1.0f-S1[nlv].y;
	  vl = vl->next; nlv++;
	}
  
    /*float cx=GraphWin.GScreen.V.Location.x;
    float cy=GraphWin.GScreen.V.Location.y;
    float cz=GraphWin.GScreen.V.Location.z;
    float le=distance(GraphWin.GScreen.V.Location, GraphWin.GScreen.V.Target);
    Vh0=GraphWin.GScreen.V.h; ua0=0.0f;
    minimize3(cx, cy, cz, 0.1f*le, 0.001f*le, &Min_C);*/
	//TextWin.Output(1,"  Vh = %f, d = %f\n", GraphWin.GScreen.V.h, distance(GraphWin.GScreen.V.Location, P1[0]));
	//float cq=CalcVQ(GraphWin.GScreen.V.Location, GraphWin.GScreen.V.Target, GraphWin.GScreen.V.Up, GraphWin.GScreen.V.h);
	//TextWin.Output(1,"  mismatch = %f\n", cq);
    vector cam, tgt, upp; float cq,d=distance(P1[0], vector(-3.649285f, 4.560094f, 2.657128f));
    /*CDC *hdc;
    hdc = GraphWin.GetDC();
    hdc->MoveTo ((int)(20.0f*d),  0);
    hdc->LineTo ((int)(20.0f*d), 30);
	for(d=0.2f; d<10.0f; d+=0.02f){
	  cq=CalcQVhd(d,GraphWin.GScreen.V.h);
	  hdc->SetPixel((int)(20.0f*d), (int)(75.0000f*cq), 32768);
	  SetViewVhd(GraphWin.GScreen.V.h, d, &cam, &tgt, &upp);
	  cq=CalcVQ(cam, tgt, upp, GraphWin.GScreen.V.h);
	  //TextWin.Output(1,"  mismatch = %f\n", cq);
	  //hdc->SetPixel((int)(20.0f*d), (int)( 0.0001f*cq),   128);
	  hdc->SetPixel((int)(20.0f*d), (int)( 0.1f*sqrt(cq)),   192);
	  //hdc->SetPixel((int)(20.0f*d), (int)( 0.0020f*cq),   240);
	}
    d=distance(P1[0], vector(-3.649285f, 4.560094f, 2.657128f));
    hdc->MoveTo ((int)(200.0f*GraphWin.GScreen.V.h),  0);
    hdc->LineTo ((int)(200.0f*GraphWin.GScreen.V.h), 30);
	for(Vh=0.1f; Vh<1.0f; Vh+=0.002f){
	  cq=CalcQVhd(d,Vh);
	  hdc->SetPixel((int)(200.0f*Vh), (int)(75.0000f*cq), 0x808000);
	  SetViewVhd(Vh, d, &cam, &tgt, &upp);
	  cq=CalcVQ(cam, tgt, upp, Vh);
	  //TextWin.Output(1,"  mismatch = %f\n", cq);
	  //hdc->SetPixel((int)(20.0f*d), (int)( 0.0001f*cq),   128);
	  hdc->SetPixel((int)(200.0f*Vh), (int)( 0.1f*sqrt(cq)),   0x800000);
	  //hdc->SetPixel((int)(20.0f*d), (int)( 0.0020f*cq),   240);
	}
    GraphWin.ReleaseDC(hdc);*/
	//SetViewVhd(GraphWin.GScreen.V.h, d, &cam, &tgt, &upp);
	//cq=CalcVQ(cam, tgt, upp, GraphWin.GScreen.V.h);
    //GraphWin.GScreen.V.Location = cam;
    //GraphWin.GScreen.V.Target   = tgt;
    //GraphWin.GScreen.V.Up       = upp;
    //GraphWin.GScreen.V.h        = Vh;
  
    //GraphWin.InvalidateRect(NULL,FALSE); WaitTask(NULL);
    /*FILE   *outfile;

    outfile = fopen("C:\\TEMP\\SURF.VMD", "wt");
    fprintf(outfile,"VMODEL VERSION 0.60\n\n");
    fprintf(outfile,"OBJECT: Camera-Matching-Function\n");
    fprintf(outfile,"AUTHOR: VModel\n\n");
    fprintf(outfile,"Settings {\n");
    fprintf(outfile,"  BACKGROUND  0.0, 0.0, 0.0\n");
    fprintf(outfile,"  AMBIENT     0.3, 0.3, 0.3\n");
    fprintf(outfile,"}\n\n");
    fprintf(outfile,"View {\n");
    fprintf(outfile,"  Camera  20, 20, 10\n");
    fprintf(outfile,"  Target   5,  5,  0\n");
    fprintf(outfile,"  Up       0,  0,  1\n");
    fprintf(outfile,"  FoVAng  30\n");
    fprintf(outfile,"}\n\n");
    fprintf(outfile,"Material default {\n");
    fprintf(outfile,"  Reflection  RGB(0.7, 0.6, 0.5)\n");
    fprintf(outfile,"  Specularity 0.3, Exponent 20, Phong\n");
    fprintf(outfile,"}\n\n");
    fprintf(outfile,"PolyMesh Surface {\n");
    fprintf(outfile,"  doublesided, rounded\n");
	fprintf(outfile,"  Material default\n");
	fprintf(outfile,"  Points %d\n",40*40);
	int x,y;
	for(x=0; x<40; x++){
	  //d=0.25f*x+0.2f;
	  d=1.0f+0.05f*x;
	  for(y=0; y<40; y++){
	    //Vh=0.025f*y+0.1f;
	    Vh=0.6f+0.005f*y;
	    SetViewVhd(Vh, d, &cam, &tgt, &upp);
	    cq=CalcVQ(cam, tgt, upp, Vh);
        fprintf(outfile,"    %f, %f, %f\n", d, 10.0f*Vh, 0.005f*sqrt(cq));
	    //cq=CalcQVhd(d,Vh);
        //fprintf(outfile,"    %f, %f, %f\n", d, 10.0f*Vh, 3.0f*cq);
	  }
	}
    fprintf(outfile,"  Faces %d\n",39*39);
	for(x=0; x<39; x++){
	  for(y=0; y<39; y++){
        fprintf(outfile,"    4  %3d, %3d, %3d, %3d\n", 40*x+y, 40*x+y+1, 40*(x+1)+y+1, 40*(x+1)+y);
	  }
	}
    fprintf(outfile,"}\n");
    fclose(outfile);*/
    CDC *hdc;
	//float s; no reference
    hdc = GraphWin.GetDC();
	for(Vh=0.1f; Vh<1.0f; Vh+=0.002f){
	  cq=Calc_d(Vh);
	  hdc->SetPixel((int)(200.0f*Vh), (int)(20.0f*g_d), 0x00F000);
	  SetViewVhd(Vh, d, &cam, &tgt, &upp);
	  cq=CalcVQ(cam, tgt, upp, Vh);
	  hdc->SetPixel((int)(200.0f*Vh), (int)(0.1f*cq),   0x0000C0);
	}
    GraphWin.ReleaseDC(hdc);
	Vh=minimize1(GraphWin.GScreen.V.h, 0.05f, 0.001f, &Calc_d);
    TextWin.Input("continue?");
    cq=Calc_d(Vh);
	SetViewVhd(Vh, g_d, &cam, &tgt, &upp);
	//SetViewVhd(0.681337f, 1.447630f, &cam, &tgt, &upp);
    GraphWin.GScreen.V.Location = cam;
    GraphWin.GScreen.V.Target   = tgt;
    GraphWin.GScreen.V.Up       = upp;
    GraphWin.GScreen.V.h        = Vh;
  
    GraphWin.InvalidateRect(NULL,FALSE); WaitTask(NULL);
	/*for(Vh=0.1f; Vh<2.0f; Vh+=0.05f){
	  cq=Calc_d(Vh);
	  SetViewVhd(Vh, g_d, &cam, &tgt, &upp);
      GraphWin.GScreen.V.Location = cam;
      GraphWin.GScreen.V.Target   = tgt;
      GraphWin.GScreen.V.Up       = upp;
      GraphWin.GScreen.V.h        = Vh;
  
      GraphWin.InvalidateRect(NULL,FALSE); WaitTask(NULL);
      TextWin.Input("weiter?");
	}*/
  }
}


void GetTex3D(PrimPtr p)
{
  BITMAPINFO  BMPinfo2; byte *BMPbits2;
  byte       *A;
  int         R,G,B;

  int width = BMPinfoB.bmiHeader.biWidth;
  int height= BMPinfoB.bmiHeader.biHeight;
  int ScLen1= ((width*3+3) & 0xFFFFFFFC);
  vector P,p1,p2,p3,p4;
  vector T,t1,t2,t3,t4;
  vector S;
  matrix E;
  int    ScLen2,fi,i,k;
  float  mxu,u;
  float  mxv,v;
  short  int XRes;
  short  int YRes;

  CDC *hdc; hdc = GraphWin.GetDC();

  Vh = GraphWin.GScreen.V.h;

  vector N = unit(GraphWin.GScreen.V.Target - GraphWin.GScreen.V.Location);
  vector V = unit(GraphWin.GScreen.V.Up-(GraphWin.GScreen.V.Up%N)*N);
  vector U = N*V; MakMat(GraphWin.GScreen.V.Location, N, U, V, &E);
  
  BITMAPFILEHEADER   FileHeader;
  FILE              *bmpfile;
  MatPtr             Mat = ((Surface *)p)->Mat;

  char texpath[260]; strcpy(texpath,filename);
  char *c = strrchr(texpath,'\\');
  if(!c) c = strrchr(texpath,':');
  c = c? c+1 : texpath;
  strcpy(c, Mat->Texture->tname);
  bmpfile = fopen(texpath,"r+b");
  if(bmpfile){
    fread(&FileHeader,1,14,bmpfile);
    if(FileHeader.bfType=='MB'){
      fread(&BMPinfo2,1,40,bmpfile);

      XRes   = (short int)BMPinfo2.bmiHeader.biWidth;
	  YRes   = (short int)BMPinfo2.bmiHeader.biHeight;
	  ScLen2 = ((XRes*3+3) & 0xFFFFFFFC);

	  BMPbits2 = new(byte[YRes*ScLen2]);

  while(p){
    if(p->idnt==POLYMESH){
	  PolyMesh *t = (PolyMesh *)p;
      for(fi=0,i=0; i<(t->nf); i++){
	    k=(t->pnv)? t->pnv[i] : 3;
        if(((k==3) || (k==4)) /*&& (t->flg[i] & SELECTED)*/){
          if(k==4){
            p1 = t->pts[t->pfv[fi  ]]; t1=t->txc[t->pft[fi  ]];
            p2 = t->pts[t->pfv[fi+1]]; t2=t->txc[t->pft[fi+1]];
	        p3 = t->pts[t->pfv[fi+2]]; t3=t->txc[t->pft[fi+2]];
	        p4 = t->pts[t->pfv[fi+3]]; t4=t->txc[t->pft[fi+3]];
	      } else {
            p2 = t->pts[t->pfv[fi  ]]; t2=t->txc[t->pft[fi  ]];
            p3 = t->pts[t->pfv[fi+1]]; t3=t->txc[t->pft[fi+1]];
	        p4 = t->pts[t->pfv[fi+2]]; t4=t->txc[t->pft[fi+2]];
	        p1 = p2+(p4-p3);           t1=t2+(t4-t3);
	      }
  
	      mxu=float(sqrt(max(sqr(XRes*t1.x-XRes*t3.x)+sqr(YRes*t1.y-YRes*t3.y), sqr(XRes*t2.x-XRes*t4.x)+sqr(YRes*t2.y-YRes*t4.y))));
	      mxv=float(sqrt(max(sqr(XRes*t1.x-XRes*t2.x)+sqr(YRes*t1.y-YRes*t2.y), sqr(XRes*t3.x-XRes*t4.x)+sqr(YRes*t3.y-YRes*t4.y))));

	      for(u=0.0f; u<=1.0f; u+=(0.666f/mxu)){
		    for(v=0.0f; v<=1.0f; v+=(0.666f/mxv)){
		      if((k==4) || ((v+u)<=1.0f)){
		        P=bilinear(u,v,p1,p2,p4,p3);
		        T=bilinear(u,v,t1,t2,t4,t3);
	            if((T.x>=0.0f) && (T.x<1.0f) && (T.y>=0.0f) && (T.y<1.0f)){
				  S = RProj(P, E, Vh, (float)width, (float)height);
	              if((S.x>=0.0f) && (S.x<width) && (S.y>=0.0f) && (S.y<height)){
		            A = BMPbitsB+((int)S.y)*ScLen1+3*(int)S.x; R=*(A+2); G=*(A+1); B=*(A);
	                hdc->SetPixel((int)((float)XRes*T.x), (int)((float)YRes*T.y), ((B)<<16)+((G)<<8)+(R));
	                *(BMPbits2+(int)((float)YRes*T.y)*ScLen2+3*(int)((float)XRes*T.x)+2) = (byte)R;
	                *(BMPbits2+(int)((float)YRes*T.y)*ScLen2+3*(int)((float)XRes*T.x)+1) = (byte)G;
	                *(BMPbits2+(int)((float)YRes*T.y)*ScLen2+3*(int)((float)XRes*T.x)  ) = (byte)B;
				  }
				}
		      }
		    }
	      }

	    }
	    fi+=k;
      }
    } else if(p->idnt==CYLINDER){
	  Cylinder *c = (Cylinder *)p;
      t1=c->txc? c->txc[0] : vector (0.0f, 0.0f, 0.0f); 
      t2=c->txc? c->txc[1] : vector (1.0f, 0.0f, 0.0f); 
      t3=c->txc? c->txc[2] : vector (0.0f, 1.0f, 0.0f); 
      t4=c->txc? c->txc[3] : vector (1.0f, 1.0f, 0.0f); 
  
	  mxu=float(sqrt(max(sqr(XRes*t1.x-XRes*t3.x)+sqr(YRes*t1.y-YRes*t3.y), sqr(XRes*t2.x-XRes*t4.x)+sqr(YRes*t2.y-YRes*t4.y))));
	  mxv=float(sqrt(max(sqr(XRes*t1.x-XRes*t2.x)+sqr(YRes*t1.y-YRes*t2.y), sqr(XRes*t3.x-XRes*t4.x)+sqr(YRes*t3.y-YRes*t4.y))));

	  for(u=0.0f; u<=1.0f; u+=(0.666f/mxu)){
	    for(v=0.0f; v<=1.0f; v+=(0.666f/mxv)){
		  P = vector(float(cos(v*(c->angle? c->angle : TwoPi))*blend(u,1.0f,c->r_top)), (1.0f-u), (float)sin(v*(c->angle? c->angle : TwoPi))*blend(u,1.0f,c->r_top))*(c->TM);
		  //P = vector(cos(v*(c->angle? c->angle : TwoPi))*blend(u,c->r_top,1.0f), (1.0f-u), sin(v*(c->angle? c->angle : TwoPi))*blend(u,c->r_top,1.0f))*(c->TM);
		  T = bilinear(u,v,t1,t2,t3,t4); 
          if((T.x>=0.0f) && (T.x<1.0f) && (T.y>=0.0f) && (T.y<1.0f)){
	        S = RProj(P, E, Vh, (float)width, (float)height);
            if((S.x>=0.0f) && (S.x<width) && (S.y>=0.0f) && (S.y<height)){
  		      A = BMPbitsB+((int)S.y)*ScLen1+3*(int)S.x; R=*(A+2); G=*(A+1); B=*(A);
	          hdc->SetPixel((int)((float)XRes*T.x), (int)((float)YRes*T.y), ((B)<<16)+((G)<<8)+(R));
              *(BMPbits2+(int)((float)YRes*T.y)*ScLen2+3*(int)((float)XRes*T.x)+2) = (byte)R;
              *(BMPbits2+(int)((float)YRes*T.y)*ScLen2+3*(int)((float)XRes*T.x)+1) = (byte)G;
              *(BMPbits2+(int)((float)YRes*T.y)*ScLen2+3*(int)((float)XRes*T.x)  ) = (byte)B;
			}
		  }
		}
	  }
    } else if(p->idnt==TORUS){
	  Torus *t = (Torus *)p;
      t1=t->txc? t->txc[0] : vector (0.0f, 0.0f, 0.0f); 
      t2=t->txc? t->txc[1] : vector (1.0f, 0.0f, 0.0f); 
      t3=t->txc? t->txc[2] : vector (0.0f, 1.0f, 0.0f); 
      t4=t->txc? t->txc[3] : vector (1.0f, 1.0f, 0.0f); 
  
	  mxu=float(sqrt(max(sqr(XRes*t1.x-XRes*t3.x)+sqr(YRes*t1.y-YRes*t3.y), sqr(XRes*t2.x-XRes*t4.x)+sqr(YRes*t2.y-YRes*t4.y))));
	  mxv=float(sqrt(max(sqr(XRes*t1.x-XRes*t2.x)+sqr(YRes*t1.y-YRes*t2.y), sqr(XRes*t3.x-XRes*t4.x)+sqr(YRes*t3.y-YRes*t4.y))));

	  for(u=0.0f; u<=1.0f; u+=(0.666f/mxu)){
	    for(v=0.0f; v<=1.0f; v+=(0.666f/mxv)){
		  P = vector((float)(cos(u*(t->vangle? t->vangle : TwoPi))*(t->R2*cos(t->ustart+v*(t->ustop - t->ustart))+t->R1)), t->R2*(float)(sin(t->ustart+v*(t->ustop - t->ustart)) ), (float)(sin(u*(t->vangle? t->vangle : TwoPi)))*(t->R2*(float)(cos(t->ustart+v*(t->ustop - t->ustart)))+t->R1)) * (t->TM);
		  T = bilinear(u,v,t1,t2,t3,t4);
          if((T.x>=0.0f) && (T.x<1.0f) && (T.y>=0.0f) && (T.y<1.0f)){
  	        S = RProj(P, E, Vh, (float)width, (float)height);
            if((S.x>=0.0f) && (S.x<width) && (S.y>=0.0f) && (S.y<height)){
		      A = BMPbitsB+((int)S.y)*ScLen1+3*(int)S.x; R=*(A+2); G=*(A+1); B=*(A);
	          hdc->SetPixel((int)((float)XRes*T.x), (int)((float)YRes*T.y), ((B)<<16)+((G)<<8)+(R));
              *(BMPbits2+(int)((float)YRes*T.y)*ScLen2+3*(int)((float)XRes*T.x)+2) = (byte)R;
              *(BMPbits2+(int)((float)YRes*T.y)*ScLen2+3*(int)((float)XRes*T.x)+1) = (byte)G;
              *(BMPbits2+(int)((float)YRes*T.y)*ScLen2+3*(int)((float)XRes*T.x)  ) = (byte)B;
			}
		  }
		}
	  }
    }
    p=p->succ;
  }

  	  //gluScaleImage(GL_BGR_EXT, XRes, YRes, GL_UNSIGNED_BYTE, BMPbits2, Mat->map->tinfo.bmiHeader.biWidth, Mat->map->tinfo.bmiHeader.biHeight, GL_UNSIGNED_BYTE, Mat->map->tbits);

      FILE *Texfile;
	  byte *bitptr;
	  int   y;

      Texfile = fopen("D:\\TEMP\\PhTex.bmp","w+b");
      if(Texfile){
        // Datei-Header initialisieren und speichern
        FileHeader.bfType      = 0x4D42;
        FileHeader.bfSize      = (BMPinfo2.bmiHeader.biSizeImage + 54);
        FileHeader.bfReserved1 = 0;
        FileHeader.bfReserved2 = 0;
        FileHeader.bfOffBits   = 54L;
    
   	    fwrite(&FileHeader,          1, 14,Texfile);
        fwrite(&(BMPinfo2.bmiHeader),1, 40,Texfile);

        // Bitmap zeilenweise abspeichern   
        bitptr=BMPbits2;
        for(y=0; y<BMPinfo2.bmiHeader.biHeight; y++){
          fwrite(bitptr,1,ScLen2,Texfile);
          bitptr += ScLen2;
        }

        fclose(Texfile);
      }

      if(BMPbits2) delete BMPbits2;

    }
	fclose(bmpfile);
  }

  GraphWin.ReleaseDC(hdc);
}


void GetTex2D()
{
  byte  *A;
  int    R,G,B;
  int    tw,width = BMPinfo1.bmiHeader.biWidth;
  int    th,height= BMPinfo1.bmiHeader.biHeight;
  int    ScLen1= ((width*3+3) & 0xFFFFFFFC);
  int    ScLen2;
  vector S,Vu,Vv,V1,V2;
  int    mxu,u,mxv,v;

  vector P1 = vector(pt[0].x, height-1-pt[0].y, 0.0f);
  vector P2 = vector(pt[1].x, height-1-pt[1].y, 0.0f);
  vector P3 = vector(pt[2].x, height-1-pt[2].y, 0.0f);
  vector P4 = vector(pt[3].x, height-1-pt[3].y, 0.0f);

  Vu = P2-P1;
  V1 = P4-P1;
  V2 = P3-P2;
  mxu=max((int)distance(P1, P2), (int)distance(P4, P3));
  mxv=max((int)distance(P1, P4), (int)distance(P2, P3));
  
  BMPinfo2.bmiHeader.biSize          = sizeof(BITMAPINFOHEADER);
  BMPinfo2.bmiHeader.biWidth         = mxu;
  BMPinfo2.bmiHeader.biHeight        = mxv;
  BMPinfo2.bmiHeader.biPlanes        = 1;
  BMPinfo2.bmiHeader.biBitCount      = 24;
  BMPinfo2.bmiHeader.biCompression   = BI_RGB;
  BMPinfo2.bmiHeader.biSizeImage     = mxv*((mxu*3+3) & 0xFFFFFFFC);
  BMPinfo2.bmiHeader.biXPelsPerMeter = 0;
  BMPinfo2.bmiHeader.biYPelsPerMeter = 0;
  BMPinfo2.bmiHeader.biClrUsed       = 0;
  BMPinfo2.bmiHeader.biClrImportant  = 0;

  //BMPinfo2=BMPinfo1;
  BMPbits2 = (byte *)malloc(BMPinfo2.bmiHeader.biSizeImage);
  ScLen2=(BMPinfo2.bmiHeader.biWidth*((BMPinfo2.bmiHeader.biBitCount)>>3)+3) & 0xFFFFFFFC;

  //memcpy(BMPbits2,BMPbits1,BMPinfo2.bmiHeader.biSizeImage);

  WNDCLASS  wndclass;

  wndclass.style         = CS_HREDRAW | CS_VREDRAW;
  wndclass.lpfnWndProc   = TexProc;
  wndclass.cbClsExtra    = 0;
  wndclass.cbWndExtra    = 0;
  wndclass.hInstance     = AfxGetInstanceHandle();
  wndclass.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
  wndclass.hCursor       = LoadCursor(NULL, IDC_ARROW);
  wndclass.hbrBackground = (struct HBRUSH__ *)GetStockObject(WHITE_BRUSH);
  wndclass.lpszMenuName  = NULL;
  wndclass.lpszClassName = "VModelTexView";
  RegisterClass(&wndclass);

  TexWin = CreateWindow ("VModelTexView",                 // Fensterklassenname
                         "Texture",                       // Titelleiste
                         WS_OVERLAPPEDWINDOW,             // Fensterstil
                         GetSystemMetrics(SM_CXSCREEN)/4, // Fensterposition, x
                         GetSystemMetrics(SM_CYSCREEN)/4, // Fensterposition, y
                         GetSystemMetrics(SM_CXSCREEN)/2, // horizontale Gre
                         GetSystemMetrics(SM_CYSCREEN)/2, // vertikale Gre
                         NULL,                            // Handle Parent-Window
                         NULL,                            // Handle Men
                         AfxGetInstanceHandle(),                           // Handle Programmkopie
                         NULL);                           // Spezialparameter


  if(BMPinfo2.bmiHeader.biHeight<680){
    tw=BMPinfo2.bmiHeader.biWidth +2*GetSystemMetrics(SM_CXFRAME);
    th=BMPinfo2.bmiHeader.biHeight+2*GetSystemMetrics(SM_CYFRAME)+GetSystemMetrics(SM_CYCAPTION)-1;
  } else {
    tw=680*BMPinfo2.bmiHeader.biWidth/BMPinfo2.bmiHeader.biHeight +2*GetSystemMetrics(SM_CXFRAME);
    th=680+2*GetSystemMetrics(SM_CYFRAME)+GetSystemMetrics(SM_CYCAPTION)-1;
  }
  MoveWindow  (TexWin,(GetSystemMetrics(SM_CXSCREEN)-tw)/2,(GetSystemMetrics(SM_CYSCREEN)-th)/2,tw,th+1,FALSE);
  ShowWindow  (TexWin,SW_SHOW);
  UpdateWindow(TexWin);

  VERIFY(TexMenu.LoadMenu(IDR_MENU2));
  pTexPopup = TexMenu.GetSubMenu(0);
  ASSERT(pTexPopup != NULL);

  HDC hdc=GetDC(TexWin);

  for(u=0; u<mxu; u++){
	for(v=0; v<mxv; v++){
	  R = 0; G = 0; B = 0; Vv=((float)u/(float)mxu)*V2+(1.0f-((float)u/(float)mxu))*V1;
      S = P1+(((float)u+0.50f)/(float)mxu)*Vu+(((float)v+0.15f)/(float)mxv)*Vv;
	  A = BMPbits1+((int)S.y)*ScLen1+3*(int)S.x; R+=*(A+2); G+=*(A+1); B+=*(A);
      S = P1+(((float)u+0.15f)/(float)mxu)*Vu+(((float)v+0.15f)/(float)mxv)*Vv;
	  A = BMPbits1+((int)S.y)*ScLen1+3*(int)S.x; R+=*(A+2); G+=*(A+1); B+=*(A);
      S = P1+(((float)u+0.85f)/(float)mxu)*Vu+(((float)v+0.15f)/(float)mxv)*Vv;
	  A = BMPbits1+((int)S.y)*ScLen1+3*(int)S.x; R+=*(A+2); G+=*(A+1); B+=*(A);
      S = P1+(((float)u+0.50f)/(float)mxu)*Vu+(((float)v+0.50f)/(float)mxv)*Vv;
	  A = BMPbits1+((int)S.y)*ScLen1+3*(int)S.x; R+=*(A+2); G+=*(A+1); B+=*(A); R+=*(A+2); G+=*(A+1); B+=*(A);
      S = P1+(((float)u+0.15f)/(float)mxu)*Vu+(((float)v+0.50f)/(float)mxv)*Vv;
	  A = BMPbits1+((int)S.y)*ScLen1+3*(int)S.x; R+=*(A+2); G+=*(A+1); B+=*(A);
      S = P1+(((float)u+0.85f)/(float)mxu)*Vu+(((float)v+0.50f)/(float)mxv)*Vv;
	  A = BMPbits1+((int)S.y)*ScLen1+3*(int)S.x; R+=*(A+2); G+=*(A+1); B+=*(A);
      S = P1+(((float)u+0.50f)/(float)mxu)*Vu+(((float)v+0.85f)/(float)mxv)*Vv;
	  A = BMPbits1+((int)S.y)*ScLen1+3*(int)S.x; R+=*(A+2); G+=*(A+1); B+=*(A);
      S = P1+(((float)u+0.15f)/(float)mxu)*Vu+(((float)v+0.85f)/(float)mxv)*Vv;
	  A = BMPbits1+((int)S.y)*ScLen1+3*(int)S.x; R+=*(A+2); G+=*(A+1); B+=*(A);
      S = P1+(((float)u+0.85f)/(float)mxu)*Vu+(((float)v+0.85f)/(float)mxv)*Vv;
	  A = BMPbits1+((int)S.y)*ScLen1+3*(int)S.x; R+=*(A+2); G+=*(A+1); B+=*(A);
      SetPixel(hdc, u, mxv-1-v, ((B/10)<<16)+((G/10)<<8)+(R/10));
      *(BMPbits2+v*ScLen2+3*u+2) = R/10;
      *(BMPbits2+v*ScLen2+3*u+1) = G/10;
      *(BMPbits2+v*ScLen2+3*u  ) = B/10;
	}
  }

  ReleaseDC(TexWin,hdc);
}
