// TextWin.cpp : implementation file
//

#include <string.h>
#include <stdio.h>
#include <stdarg.h>

#include "stdafx.h"
#include "general.h"
#include "VModel.h"
#include "Primitives.h"
#include "VModelFile.h"
#include "TextWin.h"
#include "GraphWin.h"

#define BUFFERLINES 80

#ifdef _DEBUG
  #define new DEBUG_NEW
  #undef THIS_FILE
  static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTextWin

CTextWin::CTextWin()
{
  Buffer = (char *)new(char[BUFFERLINES<<7]);
  for(int i=0; i<BUFFERLINES; i++) *(Buffer+(i<<7))=0;
}

CTextWin::~CTextWin()
{
  if(Buffer) delete Buffer;
}


BEGIN_MESSAGE_MAP(CTextWin, CWnd)
	//{{AFX_MSG_MAP(CTextWin)
	ON_WM_CREATE()
	ON_WM_CHAR()
	ON_WM_PAINT()
	ON_WM_SIZE()
	ON_WM_KILLFOCUS()
	ON_WM_SETFOCUS()
	ON_WM_KEYDOWN()
	ON_WM_KEYUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


CTextWin  TextWin;


COLORREF TextColNum(int n)
{
  switch(n){
    case 2: return 0x00C04000;
    case 3: return 0x000020C0;
    case 4: return 0x00008000;
  }
  return 0x00000000;
}


void CTextWin::WScroll()
{
  RECT rect; GetClientRect(&rect);
  CDC *hdc = GetDC();
  hdc->BitBlt(0,0,rect.right,rect.bottom-(cyChar>>2),hdc,0,(cyChar>>2),SRCCOPY);
  hdc->BitBlt(0,rect.bottom-(cyChar>>2)-1,rect.right,cyChar>>2,NULL,0,0,WHITENESS);
  hdc->BitBlt(0,0,rect.right,rect.bottom-(cyChar>>2),hdc,0,(cyChar>>2),SRCCOPY);
  hdc->BitBlt(0,0,rect.right,rect.bottom-(cyChar>>2),hdc,0,(cyChar>>2),SRCCOPY);
  hdc->BitBlt(0,0,rect.right,rect.bottom-(cyChar-3*(cyChar>>2)),hdc,0,(cyChar-3*(cyChar>>2)),SRCCOPY);
  ReleaseDC(hdc);
}


void CTextWin::Output(char color, char *Text, ...)
{
  char buf[128]; char *buf1=buf;
  // convert format-string with variable-length argument list to string
  va_list vl; va_start(vl, Text); vsprintf(buf,Text,vl); va_end(vl);

  CDC *hdc = GetDC(); int sl;
  hdc->SelectObject(GetStockObject(SYSTEM_FIXED_FONT));
  while(*buf1){
    for(sl=0; (buf1[sl] != 0) && (buf1[sl] != '\n'); sl++);
    if(sl){
      if(!px){ *(Buffer+(cl<<7))=color; px=1; cc=color; hdc->SetTextColor(TextColNum(cc)); }
      if(color != cc){ *(Buffer+(cl<<7)+px)=0; *(Buffer+(cl<<7)+px+1)=color; cc=color; hdc->SetTextColor(TextColNum(cc)); px+=2; }
      memcpy(Buffer+(cl<<7)+px, buf1, min(sl,120-px));
      hdc->TextOut(cx*cxChar,cy,Buffer+(cl<<7)+px, min(sl,120-px));
      buf1+=sl; cx+=min(sl,120-px); px+=min(sl,120-px);
      *(Buffer+(cl<<7)+px)=0; *(Buffer+(cl<<7)+px+1)=0;
    }
    if(*buf1 == '\n'){
      cx=0; px=0; buf1++; cl++; if(cl>=BUFFERLINES) cl=0;
      *(Buffer+(cl<<7)+px)=0;
      WScroll();
    }
  }
  ReleaseDC(hdc);
}


void CTextWin::Complete(char *Text, ...)
{
  char buf[128]; char *buf1=buf; int x,l=cl-1; if(l<0) l=BUFFERLINES-1;
  // convert format-string with variable-length argument list to string
  va_list vl; va_start(vl, Text); vsprintf(buf,Text,vl); va_end(vl);
  // find point to append completion string
  for(x=0;!((*(Buffer+(l<<7)+x)==0) && (*(Buffer+(l<<7)+x+1)==0)); x++);
  // copy string to textbuffer
  CDC *hdc = GetDC(); int sl=strlen(buf1);
  hdc->SelectObject(GetStockObject(SYSTEM_FIXED_FONT));
  hdc->SetTextColor(0x00C04000); *(Buffer+(l<<7)+x)=' '; x++;
  memcpy(Buffer+(l<<7)+x, buf1, min(sl,120-x));
  hdc->TextOut((x-3)*cxChar,cy-cyChar,Buffer+(l<<7)+x, min(sl,120-px));
  x+=min(sl,120-px);
  *(Buffer+(l<<7)+x)=0; *(Buffer+(l<<7)+x+1)=0;
  ReleaseDC(hdc);
}


int CTextWin::Input(char *prompt)
{
  MSG msg;
  Output(1,prompt);
  *(Buffer+(cl<<7)+px++) = 0;
  *(Buffer+(cl<<7)+px++) = 2;
  *(Buffer+(cl<<7)+px)   = 0;
  inputposition=px; inputactive=TRUE; //NoInput=FALSE;
  if(GetFocus()==this){
    CreateSolidCaret(cxChar,cyChar);
    POINT p = {cx*cxChar, cy}; SetCaretPos(p);
    ShowCaret();
  }
  while(inputactive){
    GetMessage(&msg, NULL, 0, 0);
    TranslateMessage(&msg);
    DispatchMessage(&msg);
  }
  if(GetFocus()==this){
    HideCaret();
    DestroyCaret();
  }
  return 0; // OK!
}

void CTextWin::KeyIn(char *Command, ...)
{
  if(inputactive){
    char buf[128]; char *buf1=buf;
    // convert format-string with variable-length argument list to string
    va_list vl; va_start(vl, Command); vsprintf(buf,Command,vl); va_end(vl);

    CDC  *hdc = GetDC();
    HideCaret();
    int l=strlen(buf);
    if(l){
      if(buf[l-1]=='\n') l--;
      if(l){
        strncpy(Buffer+(cl<<7)+px, buf, l);
        hdc->SelectObject(GetStockObject(SYSTEM_FIXED_FONT));
        hdc->SetTextColor(0x00C04000);
        hdc->TextOut(cx*cxChar, cy, Buffer+(cl<<7)+px, l); cx+=l;
        *(Buffer+(cl<<7)+px+l)=0; *(Buffer+(cl<<7)+px+l+1)=0; px+=l;
      }
      if(buf[l]=='\n'){
        strcpy(inputstring,Buffer+(cl<<7)+inputposition);
        cx=0; px=0; cl++; if(cl>=BUFFERLINES) cl=0;
        WScroll();
        inputactive=FALSE;
      }
      POINT p = {cx*cxChar, cy}; SetCaretPos(p);
    }
    ShowCaret();
    ReleaseDC(hdc);
  }
}


/////////////////////////////////////////////////////////////////////////////
// CTextWin message handlers

int CTextWin::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
  TEXTMETRIC  tm;
  CDC        *hdc=GetDC();
  RECT        rect; GetClientRect(&rect);
  hdc->SelectObject(GetStockObject(SYSTEM_FIXED_FONT));
  hdc->GetTextMetrics(&tm);
  cxChar=tm.tmAveCharWidth;
  cyChar=tm.tmHeight;
  ReleaseDC(hdc);
  px=0; cx=0; cy=0; cl=0; cc=1;
  return 0;
}

void CTextWin::OnPaint() 
{
  CPaintDC dc(this);
  if(!IsIconic()){
    RECT rect; GetClientRect(&rect);
    int  lines=rect.bottom/cyChar;
    dc.SelectObject(GetStockObject(SYSTEM_FIXED_FONT));
    HideCaret();
    for(int i=0; i<=lines; i++){
      int l,x=0, p=0, z=(((cl-i)+BUFFERLINES)%BUFFERLINES)<<7;
      while((*(Buffer+z+p)) && (*(Buffer+z+p+1))){
        dc.SetTextColor(TextColNum(*(Buffer+z+p)));
        l=strlen(Buffer+z+p+1);
        dc.TextOut(x*cxChar,cy-i*cyChar,Buffer+z+p+1,l);
        p+=(l+2); x+=l;
      }
    }
    POINT p = {cx*cxChar, cy}; SetCaretPos(p);
    ShowCaret();
  }
}

void CTextWin::OnSize(UINT nType, int sx, int sy) 
{
  cy=sy-cyChar-1;
  InvalidateRect(NULL,TRUE);
}

void CTextWin::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
  if(inputactive){
    CDC  *hdc = GetDC();
    HideCaret();
    for(UINT i=0; i<nRepCnt; i++){
      switch(nChar){
        case '\n':
        case '\r':
          strcpy(inputstring,Buffer+(cl<<7)+inputposition);
          cx=0; px=0; cl++; if(cl>=BUFFERLINES) cl=0;
          WScroll();
          inputactive=FALSE;
          break;
        case '\b':
          if(px>inputposition){
            cx--; px--;
            hdc->SelectObject(GetStockObject(SYSTEM_FIXED_FONT));
            hdc->TextOut(cx*cxChar, cy, " ", 1);
	    *(Buffer+(cl<<7)+px)=0; *(Buffer+(cl<<7)+px+1)=0;
          }
          break;
        default:
          *(Buffer+(cl<<7)+px) = (char)nChar;
          hdc->SelectObject(GetStockObject(SYSTEM_FIXED_FONT));
          hdc->SetTextColor(0x00C04000);
          hdc->TextOut(cx*cxChar, cy, Buffer+(cl<<7)+px, 1); cx++;
	  *(Buffer+(cl<<7)+px+1)=0; *(Buffer+(cl<<7)+px+2)=0; px++;
          break;
      }
    }
    POINT p = {cx*cxChar, cy}; SetCaretPos(p);
    ShowCaret();
    ReleaseDC(hdc);
  }
}

void CTextWin::OnKillFocus(CWnd* pNewWnd) 
{
  if(inputactive){
    HideCaret();
    DestroyCaret();
  }
}

void CTextWin::OnSetFocus(CWnd* pOldWnd) 
{
  if(inputactive){
    CreateSolidCaret(cxChar,cyChar);
    POINT p = {cx*cxChar, cy}; SetCaretPos(p);
    ShowCaret();
  }
}

int go=0; DWORD gs;

void CTextWin::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
  // TODO: Add your message handler code here and/or call default
  //char txt[80]; sprintf(txt,"Key %d, Rep %d, Flags %d.",nChar,nRepCnt,nFlags);
  //MessageBox(txt, "Key", MB_OK);
  if(GraphWin.InputMode == IM_DRAG){
    if(nChar==27){ // ESC
	  if(GetCapture() == &GraphWin){
        ReleaseCapture(); GraphWin.InputMode = IM_NONE;
      }
    }
	if(GraphWin.DragMode == DM_VWALK){
      if((nChar==38) && (go!= 2)){ // Up
        go= 2; gs = GetTickCount();
	  }
      if((nChar==40) && (go!=-2)){ // Down
        go=-2; gs = GetTickCount();
	  }
	}
  } else CWnd::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CTextWin::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
  if(GraphWin.InputMode == IM_DRAG){
	if(GraphWin.DragMode == DM_VWALK){
      if(nChar==38){ // Up
        go= 1;
	  }
      if(nChar==40){ // Down
        go=-1;
	  }
	}
  } else CWnd::OnKeyUp(nChar, nRepCnt, nFlags);
}

