// Virtual Modeller V0.5GL  for MS Visual C++ V4.2   25.09.1998  Michael Granz
//
// VModel.h : main header file for the VMODEL application

#ifndef __AFXWIN_H__
  #error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h" // main symbols

#define PICKDIST      3  // maximum distance (in pixels) to an object to pick

#define Pi_2    1.5707963F
#define Pi_3    4.7123890F
#define epsilon 0.001F

#define SKIP        1
#define TURN        2
#define SELECTED    8
#define MATCH      16
#define REMOVED    32
#define JUSTIFIED  64
#define FINISHED  128
#define VISIBLE   512

#define DRAW_VISIBLE    1
#define DRAW_ALL       64
#define DRAW_DETAILED 128

#define NO_NORMAL 65500

#define LINE_DOUBLESIDED     4
#define LINE_CROSSLINE      32
#define LINE_INVERSE       256

#define EDGE_VISIBLE  1
#define EDGE_ATFRONT  2
#define EDGE_CONTOUR  4
#define EDGE_ENDLIST  8
#define EDGE_CROSS   16

typedef struct { byte   B,G,R; } RGBcolor;
typedef struct { float  R,G,B; } RGBcol;
typedef struct { vector p1,p2; byte md; } VNode;
typedef struct { ushort x,y,z; } ScrPos;

typedef struct VLNode    *VLPtr;
typedef struct Lite      *LtPtr;

struct triang { ushort v1,v2,v3; ushort n1,n2,n3; byte flags; };

struct VLNode { VLPtr next; vector pg,pp,pe; int edg; };
struct Lite   { LtPtr next; vector p; float v; };

extern ushort     OGLT;
extern int        SPx,SPy, EPx,EPy;
extern HICON      AppIcon;


class CVModelApp : public CWinApp
{
  public: CVModelApp();

  // Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CVModelApp)
	public:
        virtual BOOL InitInstance();
	virtual CDocument* OpenDocumentFile(LPCTSTR lpszFileName);
	virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);
	//}}AFX_VIRTUAL

  // Implementation

        //{{AFX_MSG(CVModelApp)
        afx_msg void OnAppAbout();
	afx_msg void OnViewDolly();
	afx_msg void OnViewRotate();
	afx_msg void OnViewLookaround();
	afx_msg void OnViewWalk();
	afx_msg void OnDisplayShaded();
	afx_msg void OnUpdateDisplayShaded(CCmdUI* pCmdUI);
	afx_msg void OnModifyObjectErase();
	afx_msg void OnViewZoomAngle();
	afx_msg void OnViewRestoreTop();
	afx_msg void OnViewRestoreFront();
	afx_msg void OnViewRestoreRight();
	afx_msg void OnViewZoomDynamic();
	afx_msg void OnViewPan();
	afx_msg void OnDisplayPerspective();
	afx_msg void OnUpdateDisplayPerspective(CCmdUI* pCmdUI);
	afx_msg void OnDisplayShowInverse();
	afx_msg void OnDisplayShowNot();
	afx_msg void OnDisplayShowOnly();
	afx_msg void OnDisplayShowAll();
	afx_msg void OnModifyObjectDoublesided();
	afx_msg void OnModifyObjectSinglesided();
	afx_msg void OnModifyObjectFacetted();
	afx_msg void OnModifyObjectSmooth();
	afx_msg void OnModifyObjectMerge();
	afx_msg void OnModifyFaceSep();
	afx_msg void OnViewPrevious();
	afx_msg void OnUpdateViewPrevious(CCmdUI* pCmdUI);
	afx_msg void OnModifyFaceDelete();
	afx_msg void OnModifyFaceSmoothingGroup1();
	afx_msg void OnModifyFaceSmoothingGroup2();
	afx_msg void OnModifyFaceSmoothingGroup3();
	afx_msg void OnModifyFaceSmoothingGroup4();
	afx_msg void OnModifyFaceSmoothingNone();
	afx_msg void OnImport3DS();
	afx_msg void OnModObjNormFlip();
	afx_msg void OnExportPOV();
	afx_msg void OnNormalsUnify();
	afx_msg void OnOptimizeMesh();
	afx_msg void OnFileImportVrml();
	afx_msg void OnImportWRL();
	afx_msg void OnFaceFlip();
	afx_msg void OnSplitConnected();
	afx_msg void OnImportLWO();
	afx_msg void OnExportDXF();
	afx_msg void OnImportDXF();
	afx_msg void OnImportObj();
	afx_msg void OnViewAuto();
	afx_msg void OnDisplayTextures();
	afx_msg void OnUpdateDisplayTextures(CCmdUI* pCmdUI);
	afx_msg void OnRaytrace();
	afx_msg void OnPhGetTex2D();
	afx_msg void OnPhGetTex3D();
	afx_msg void OnFileInfo();
	afx_msg void OnModifyObjectMove();
	afx_msg void OnMeasureCoords();
	afx_msg void OnPhOpenExt();
	afx_msg void OnPhOpenBack();
	afx_msg void OnPhLink();
	afx_msg void OnViewSave();
	afx_msg void OnFaceMap();
	afx_msg void OnUpdateDisplayAa(CCmdUI* pCmdUI);
	afx_msg void OnDisplayAa();
	afx_msg void OnModifyObjectUnmap();
	afx_msg void OnExportRib();
	afx_msg void OnExportVRML();
	afx_msg void OnExportVL();
	afx_msg void OnRotateZ();
	afx_msg void OnRotateY();
	afx_msg void OnRotateX();
	afx_msg void OnCreatePolygon();
	afx_msg void OnCreateCylinder();
	afx_msg void OnViewRestoreLeft();
	afx_msg void OnPhMatch1();
	afx_msg void OnPhMatchVhd();
	afx_msg void OnPhotoMatch2();
	afx_msg void OnPhLinkEdge();
	afx_msg void OnImportDEM();
	afx_msg void OnSplitMaterials();
	afx_msg void OnImportGEO();
	//}}AFX_MSG
        DECLARE_MESSAGE_MAP()
};

