// VModelDoc.cpp : implementation of the CVModelDoc class
//

#include "stdafx.h"
#include "general.h"
#include "Primitives.h"
#include "VModel.h"
#include "VModelFile.h"
#include "VModelDoc.h"
#include "TextWin.h"
#include "GraphWin.h"

extern "C" {
  #include "OpenImage.h"
}

extern TexMapPtr   ltexture;
extern byte       *BMPbitsB;

#include "gl\gl.h"

#ifdef _DEBUG
  #define new DEBUG_NEW
  #undef THIS_FILE
  static char THIS_FILE[] = __FILE__;
#endif

CVModelDoc *VMDoc;
/////////////////////////////////////////////////////////////////////////////
// CVModelDoc

IMPLEMENT_DYNCREATE(CVModelDoc, CDocument)

BEGIN_MESSAGE_MAP(CVModelDoc, CDocument)
	//{{AFX_MSG_MAP(CVModelDoc)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_FILE_NEW, OnFileNew)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	ON_COMMAND(ID_FILE_SAVE_AS, OnFileSaveAs)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CVModelDoc::CVModelDoc()  { VMDoc = this; InitDoc(); }

CVModelDoc::~CVModelDoc() {               KillDoc(); }


void CVModelDoc::InitDoc(void)
{
  VMF.Init(); ViewStack=NULL; VLList=NULL; Lights=NULL;
  
  OGLP = 2; OGLT = 2; ltexture = NULL;
}

void CVModelDoc::KillDoc(void)
{
  TexMapPtr  tp=VMF.TexList;
  ViewPtr    vp;

  glDeleteLists(2,OGLP);
  while(tp){
    if(tp->glbits) delete tp->glbits;
    glDeleteTextures(1,&(tp->glname));
	tp=tp->next;
  }
  while(ViewStack) { vp=ViewStack; ViewStack = ViewStack->next; delete(vp); }
  if(BMPbitsB){ QuitImage(BMPbitsB); BMPbitsB=NULL; }
  VMF.Kill();
}


/////////////////////////////////////////////////////////////////////////////
// CVModelDoc diagnostics

#ifdef _DEBUG

  void CVModelDoc::AssertValid() const
  {
    CDocument::AssertValid();
  }

  void CVModelDoc::Dump(CDumpContext& dc) const
  {
    CDocument::Dump(dc);
  }

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CVModelDoc commands


void CVModelDoc::OnFileOpen()   { TextWin.KeyIn("LOAD\n"  ); }
void CVModelDoc::OnFileNew()    { TextWin.KeyIn("NEW\n"   ); }
void CVModelDoc::OnFileSave()   { TextWin.KeyIn("SAVE\n"  ); }
void CVModelDoc::OnFileSaveAs() { TextWin.KeyIn("SAVEAS\n"); }
