// VModelDoc.h : interface of the CVModelDoc class
//
/////////////////////////////////////////////////////////////////////////////

class CVModelDoc : public CDocument
{
  protected: // create from serialization only
    CVModelDoc();
    DECLARE_DYNCREATE(CVModelDoc)

  // Attributes
  public:
	VModelFile VMF;          // vmodel file content

    BOOL       WorldValid;   // quader-representation of the hole world
    vector     WMP;          // world-middle-point
    float      WRD;          // world-maximum-radius

    vector     DefLit;
    ViewPtr    ViewStack;

    VLPtr      VLList;
    LtPtr      Lights;

  // Operations
  public:
    void InitDoc(void);
	void KillDoc(void);
	void Load(char *filename, ViewPtr V);
	void Save(char *filename, ViewPtr V);
	void ImportVRML(char *filename, ViewPtr V);
	void Import3DS (char *filename, ViewPtr V);
	void Import4DS (char *filename, ViewPtr V);
	void ImportLWO (char *filename, ViewPtr V);
	void ImportOBJ (char *filename, ViewPtr V);
	void ImportDXF (char *filename, ViewPtr V);
	void ImportDEM (char *filename, ViewPtr V);
    void ImportGEO (char *filename, ViewPtr V);
	void ExportPOV (char *filename, ViewPtr V);
	void ExportDXF (char *filename, ViewPtr V);
	void ExportRIB (char *filename, ViewPtr V);
	void ExportVRML(char *filename, ViewPtr V);
	void ExportVIB (char *filename, ViewPtr V);

  // Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CVModelDoc)
	//}}AFX_VIRTUAL

  // Implementation
  public:
    virtual ~CVModelDoc();
    #ifdef _DEBUG
      virtual void AssertValid() const;
      virtual void Dump(CDumpContext& dc) const;
    #endif

  protected:

  // Generated message map functions
  protected:
	//{{AFX_MSG(CVModelDoc)
	afx_msg void OnFileOpen();
	afx_msg void OnFileNew();
	afx_msg void OnFileSave();
	afx_msg void OnFileSaveAs();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

extern CVModelDoc *VMDoc;