// VModelView.cpp : implementation of the CVModelView class
//

#include "stdafx.h"
#include "general.h"
#include "Primitives.h"
#include "VModel.h"

#include "VModelFile.h"
#include "VModelDoc.h"
#include "VModelView.h"

#include "GraphWin.h"
#include "TextWin.h"

#ifdef _DEBUG
  #define new DEBUG_NEW
  #undef THIS_FILE
  static char THIS_FILE[] = __FILE__;
#endif

CVModelView *VMView;

/////////////////////////////////////////////////////////////////////////////
// CVModelView

IMPLEMENT_DYNCREATE(CVModelView, CView)

BEGIN_MESSAGE_MAP(CVModelView, CView)
	//{{AFX_MSG_MAP(CVModelView)
	ON_WM_CREATE()
	ON_WM_ERASEBKGND()
	ON_WM_SIZE()
	ON_WM_SETFOCUS()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CVModelView::CVModelView()
{
  VMView = this;
}

CVModelView::~CVModelView() { }


BOOL CVModelView::PreCreateWindow(CREATESTRUCT& cs)
{
  // TODO: Modify the Window class or styles here by modifying the CREATESTRUCT cs
  return CView::PreCreateWindow(cs);
}

void CVModelView::OnDraw(CDC* pDC)
{
  CVModelDoc* pDoc = GetDocument();
  ASSERT_VALID(pDoc);
  // TODO: add draw code for native data here
}


/////////////////////////////////////////////////////////////////////////////
// CVModelView diagnostics

#ifdef _DEBUG

  void CVModelView::AssertValid() const
  {
    CView::AssertValid();
  }

  void CVModelView::Dump(CDumpContext& dc) const
  {
    CView::Dump(dc);
  }

  CVModelDoc* CVModelView::GetDocument() // non-debug version is inline
  {
    ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CVModelDoc)));
    return (CVModelDoc*)m_pDocument;
  }

#endif //_DEBUG


/////////////////////////////////////////////////////////////////////////////
// CVModelView message handlers

int CVModelView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
  if (CView::OnCreate(lpCreateStruct) == -1) return -1;
	
  CString GraphClass = AfxRegisterWndClass(CS_HREDRAW | CS_VREDRAW, LoadCursor(NULL,IDC_CROSS), (HBRUSH)GetStockObject(WHITE_BRUSH), AppIcon);
  CString TextClass  = AfxRegisterWndClass(CS_HREDRAW | CS_VREDRAW, LoadCursor(NULL,IDC_CROSS), (HBRUSH)GetStockObject(WHITE_BRUSH), AppIcon);
  
  RECT rect;
  
  rect.left = -1; rect.top = -1; rect.right = 160; rect.bottom = 120;
  GraphWin.Create(GraphClass ,"<unbenannt>", WS_CHILD | WS_CAPTION | WS_THICKFRAME | WS_CLIPSIBLINGS | WS_CLIPCHILDREN, rect, this, 1, NULL);
  GraphWin.ShowWindow(SW_SHOWNORMAL);
  GraphWin.UpdateWindow();

  rect.left = 10; rect.top = 10; rect.right = 160; rect.bottom = 120;
  TextWin.Create(TextClass ,"Text Interface", WS_CHILD | WS_CAPTION | WS_THICKFRAME | WS_CLIPSIBLINGS, rect, this, 1, NULL);
  TextWin.ShowWindow(SW_SHOWNORMAL);
  TextWin.UpdateWindow();
	
  return 0;
}


BOOL CVModelView::OnEraseBkgnd(CDC* pDC){ return TRUE; }


void CVModelView::OnSize(UINT nType, int cx, int cy) 
{
  GraphWin.MoveWindow(-1,-1,cx+1,cy-72+1);
  TextWin.MoveWindow(-1,cy-72,cx+1,72);
}

void CVModelView::OnSetFocus(CWnd* pOldWnd) 
{
  TextWin.SetFocus();	
}
